<!-- ***************************************************************** -->
<sect>Moving On
<!-- ***************************************************************** -->

<!-- ----------------------------------------------------------------- -->
<sect1>Data Types
<p>
There are a few things you probably noticed in the previous examples
that need explaining. The gint, gchar etc. that you see are typedefs
to int and char respectively. This is done to get around that nasty
dependency on the size of simple data types when doing calculations.

A good example is "gint32" which will be typedef'd to a 32 bit integer
for any given platform, whether it be the 64 bit alpha, or the 32 bit
i386. The typedefs are very straight forward and intuitive. They are
all defined in glib/glib.h (which gets included from gtk.h).

<!-- ----------------------------------------------------------------- -->
<sect1>More on Signal Handlers
<p>

Lets take another look at the gtk_signal_connect declaration.

<tscreen><verb>
SigC::Connection Signal1&lt;void,int&gt;::connect( Slot1&lt;void,int&gt;&amp; );
</verb></tscreen>

Notice the Connection return value? This is a handler which
controls that perticular connect to the callback function. As stated above, 
you may have as many callbacks per signal and per object as you need, and 
each will be executed in turn, in the order they were attached.

This tag allows you to remove this callback from the list by using:

<tscreen><verb>
Connection::disconnect();
</verb></tscreen>

Simply calling this method breaks the connection thus preventing
it from being called again.

divert(-1)
Another function to remove all the signal handers from an object is:

!!!!!!!!! <-- I am not sure that we have such a beast right now -->
<tscreen><verb>
void gtk_signal_handlers_destroy( GtkObject *object );
</verb></tscreen>

This call is fairly self explanatory. It simply removes all the
current signal handlers from the object passed in as the first
argument.
!!!!!!!!

divert(0)

<!-- ----------------------------------------------------------------- -->
<sect1>An Upgraded Hello World
<p>
Let's take a look at a slightly improved <em>helloworld</em> with
better examples of callbacks. This will also introduce us to our next
topic, packing widgets.

<tscreen><verb>
example_include(helloworld2/helloworld2.cc)
</verb></tscreen>

Compile this program using the same linking arguments as our first
example.  You'll notice this time there is no easy way to exit the
program, you have to use your window manager or command line to kill
it. A good exercise for the reader would be to insert a third "Quit"
button that will exit the program. You may also wish to play with the
options to pack_start() while reading the next section.  Try
resizing the window, and observe the behavior.

Just as a side note, there is another useful constant for the
Gtk_Window ctor - GTK_WINDOW_DIALOG. This interacts with the window
manager a little differently and should be used for transient windows.

