<!doctype linuxdoc system>

<!-- This is the tutorial marked up in SGML
     (just to show how to write a comment)

dnl  We are going to use M4 to do so text manipulation here
dnl  The next lines are directives to M4.
define(EXAMPLE_DIR,../../examples)
include(sgml.macros.m4)
-->

<article>
<title>Gtk-- v1.0 Tutorial
<author>
Guillaume Laurent <tt><htmlurl url="mailto:glaurent@worldnet.fr"
			      name="&lt;glaurent@worldnet.fr&gt;"></tt>

Chapter on "Timeouts" contributed by Bernhard Rieder
	<tt><htmlurl url="mailto:e9325898@student.tuwien.ac.at"
                     name="&lt;e9325898@student.tuwien.ac.at&gt;"></tt>

Adapted from the GTK Tutorial by

Tony Gale <tt><htmlurl url="mailto:gale@gtk.org"
			      name="&lt;gale@gtk.org&gt;"></tt>
Ian Main <tt><htmlurl url="mailto:imain@gtk.org"
			      name="&lt;imain@gtk.org&gt;"></tt>,
<date>August 20st, 1999
<abstract>
This is a tutorial on how to use Gtk-- (the C++ bindings to GTK).
</abstract>

<!-- Table of contents -->
<!-- Older versions of this tutorial did not have a table of contents,
     but the tutorial is now so large that having one is very useful. -->
<toc>
 
include(introduction.sgml.m4)
include(getting_started.sgml.m4)
include(moving_on.sgml.m4)
include(widget_overview.sgml.m4)
include(button_widgets.sgml.m4)
include(adjustments.sgml.m4)
include(range_widgets.sgml.m4)
include(misc_widgets.sgml.m4)
include(container.sgml.m4)
include(packing_widgets.sgml.m4)
include(clist_widget.sgml.m4)
dnl include(tree_widget.sgml.m4)
dnl include(menu_widget.sgml.m4)
dnl include(text_widget.sgml.m4)
dnl include(undocumented.sgml.m4)
dnl include(attributes.sgml.m4)
dnl include(timeouts.sgml.m4)
dnl include(advanced_events.sgml.m4)
dnl include(selections.sgml.m4)
dnl include(glib.sgml.m4)
dnl include(rc_files.sgml.m4)
dnl include(writing_widgets.sgml.m4)
include(scribble.sgml.m4)
dnl include(tips.sgml.m4)
include(contributing.sgml.m4)
include(credits.sgml.m4)
include(notice.sgml.m4)

<!-- ***************************************************************** -->
<appendix>
<!-- ***************************************************************** -->

dnl include(gtkmm_signals.sgml.m4)
dnl include(gdk_events.sgml.m4)
dnl include(code_examples.sgml.m4)
dnl include(list_widget.sgml.m4)

</article>
