/* example-start eventbox eventbox.c */

#include <gtk--/window.h>
#include <gtk--/main.h>
#include <gtk--/eventbox.h>
#include <gtk--/label.h>

class AppWindow : public Gtk_Window
{
public:
  AppWindow();
  ~AppWindow();

  virtual gint delete_event_impl (GdkEventAny*);
  gint callback(GdkEventButton*)
    { 
      Gtk_Main::quit();
      return 1;
    }
};


AppWindow::AppWindow()
  : Gtk_Window(GTK_WINDOW_TOPLEVEL)
{
  Gtk_EventBox *event_box;
  Gtk_Label *label;

  set_title ("Event Box");
  set_border_width (10);

  /* Create an EventBox and add it to our toplevel window */
    
  event_box = manage( new Gtk_EventBox () );
  add (*event_box);

  /* Create a long label */
    
  label = manage( new Gtk_Label ("Click here to quit, quit, quit, quit, quit") );
  event_box-> add (*label);

  /* Clip it short. */
  label->set_usize (110, 20);

  /* And bind an action to it */
  event_box->set_events (GDK_BUTTON_PRESS_MASK);
  event_box->button_press_event.connect(slot(*this, &AppWindow::callback));
    
  /* Yet one more thing you need an X window for ... */
    
  event_box->realize ();
//  event_box->get_window().set_cursor (gdk_cursor_new (GDK_HAND1));

  show_all ();    
}

AppWindow::~AppWindow() {}

gint AppWindow::delete_event_impl (GdkEventAny*)
{
  Gtk_Main::quit();
  return 0;
}


int 
main (int argc, char *argv[])
{
    
    Gtk_Main main (argc, argv);
    AppWindow window;
    
    Gtk_Main::run();
    
    return(0);
}
/* example-end */
