#include <gnome--.h>



class RoseCanvas : public Gnome_Canvas
{
  Gnome_CanvasGroup m_canvasgroup;
  Gnome_CanvasLine *m_line;
  Gnome_CanvasEllipse *m_ellipse;
  Gnome_CanvasRect *m_rect;
  Gnome_CanvasImage *m_image;
  
public:
  RoseCanvas();
};

class MainWin : public Gnome_Main
{
  RoseCanvas m_canvas;
  Gnome_App m_app;
  
public:
  MainWin(const gchar * appname, const gchar * title,
	  const char *app_id, const char *app_version,
	  int argc, char **argv);

  gint delete_event_impl(GdkEventAny*) { 
    Gtk_Main::instance()->quit(); return 0; 
  }
  
};

RoseCanvas::RoseCanvas()
  : m_canvasgroup(root(), 0, 0)
{

  // create some elements there
  Gnome_CanvasPoints points;
  
  points.push_back(gpoint(0, 0));
  points.push_back(gpoint(100,0));
  points.push_back(gpoint(0,100));
  points.push_back(gpoint(100,100));

  m_line = new Gnome_CanvasLine(m_canvasgroup,
				"points", points.gtkobj(),
				"fill_color", "black",
				"width_units", 1.0,
				"cap_style", GDK_CAP_ROUND,
				NULL);

  (*m_line).set_fill_color("red").set_width_units(4.0);

  m_ellipse = new Gnome_CanvasEllipse(m_canvasgroup);

  (*m_ellipse).set_x1(0).set_y1(0).
    set_x2(100).set_y2(100).set_fill_color("blue");

  m_rect = new Gnome_CanvasRect(m_canvasgroup,
				"width_pixels", 2,
				"fill_color", "white",
				NULL);

  (*m_rect).set_x1(10).set_y1(10).
    set_x2(50).set_y2(100).set_fill_color("white");

  m_image = new Gnome_CanvasImage(m_canvasgroup);

  Gdk_Imlib::Image toroid("toroid.png");
  m_image->set_image(toroid);

}

MainWin::MainWin(const gchar * appname, const gchar * title,
		 const char *app_id, const char *app_version,
		 int argc, char **argv)
  : Gnome_Main(app_id, app_version, argc, argv),
    m_app(appname, title)
{
  m_app.set_contents(m_canvas);
  
  m_app.show_all();
};

int main(int argc, char *argv[])
{
  MainWin mainwin("RoseExperiment", "Rosegarden Experiment", "Rose", "0.0",
		  argc, argv);
  
  mainwin.run();
  return 0;
}

