#include <gtk--/main.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fstream>

ifstream input;


// this will be our callback for read operations
// there is not much to say. just read a string,
// print it and quit the application if the string was quit
void MyCallback(int, GdkInputCondition) {
  string dummy;
  do {
    input >> dummy;
    cout << dummy << endl;
    if(dummy == "quit") Gtk_Main::quit();
  } while(input.fail());
}


int main (int argc, char *argv[])
{
  // the usual Gtk_Main object
  Gtk_Main app(argc, argv);

  // create a fifo for testing purposes
  if (mkfifo("testfifo",0666) != 0) { 
    cerr << "error creating fifo" << endl;
    return -1;
  }
  
  // open the fifo
  int fd = open("testfifo", 0);
  if (fd == -1) {
    cerr << "error opening fifo" << endl;
    return -1;
  }

  // assign the fifo's filedescriptor to our ifstream object
  input.attach(fd);
  
  // connect the callback function
  app.input.connect(slot(MyCallback), fd, GDK_INPUT_READ);

  // and last but not least - run the application main loop
  app.run();

  // now remove the temporary fifo
  if(unlink("testfifo")) 
    cerr << "error removing fifo" << endl;

  return 0;
}
