#include <stdio.h>
#include <gtk--/checkbutton.h>
#include <gtk--/window.h>
#include <gtk--/frame.h>
#include <gtk--/box.h>
#include <gtk--/main.h>
#include <gtk--/spinbutton.h>
#include <gtk--/label.h>

class ToggleSnap: public Gtk_CheckButton
{
  Gtk_SpinButton* spin_;
public:
  ToggleSnap(Gtk_SpinButton *spin,const string& s) 
      : Gtk_CheckButton(s), spin_(spin)
    {}
  void clicked_impl()
    { 
      Gtk_CheckButton::clicked_impl();
      spin_->set_snap_to_ticks(get_active()); 
    }
};

class ToggleNumeric: public Gtk_CheckButton
{
  Gtk_SpinButton* spin_;
public:
  ToggleNumeric(Gtk_SpinButton *spin,const string& s) 
      : Gtk_CheckButton(s), spin_(spin)
    {}
  void clicked_impl()
    { 
      Gtk_CheckButton::clicked_impl();
      spin_->set_numeric(get_active()); 
    }
};

class AppWindow : public Gtk_Window
{
  Gtk_SpinButton *spinner1;
  Gtk_Label  *val_label;
public:
  AppWindow();
  ~AppWindow();

  /* It's a good idea to do this for all application windows. */
  gint delete_event_impl (GdkEventAny*)
  {
    Gtk_Main::quit();
    return 0;
  }

  void change_digits( Gtk_SpinButton *spin );
  void get_value(int display );

};


void AppWindow::change_digits( Gtk_SpinButton *spin )
{
  spinner1->set_digits ( spin->get_value_as_int ());
}

void AppWindow::get_value(int display )
{
  gchar buf[32];

  if (display == 1)
    sprintf (buf, "%d", spinner1->get_value_as_int ());
  else
    sprintf (buf, "%0.*f", spinner1->gtkobj()->digits,
             spinner1->get_value_as_float ());
  val_label->set_text (buf);
}


AppWindow::AppWindow()
  : Gtk_Window (GTK_WINDOW_TOPLEVEL)
{
  Gtk_Frame      *frame;
  Gtk_Box        *hbox;
  Gtk_Box        *main_vbox;
  Gtk_Box        *vbox;
  Gtk_Box        *vbox2;
  Gtk_SpinButton *spinner2;
  Gtk_SpinButton *spinner;
  Gtk_Button     *button;
  Gtk_CheckButton *checkbutton;
  Gtk_Label      *label;
  Gtk_Adjustment *adj;

  set_title ("Spin Button");

  main_vbox = manage( new Gtk_VBox (FALSE, 5) );
  main_vbox->set_border_width (10);
  add (*main_vbox);
  
  frame = manage( new Gtk_Frame ("Not accelerated") );
  main_vbox->pack_start (*frame, TRUE, TRUE, 0);
  
  vbox = manage( new Gtk_VBox (FALSE, 0) );
  vbox->set_border_width (5);
  frame->add (*vbox);
  
  /* Day, month, year spinners */
  
  hbox = manage( new Gtk_HBox (FALSE, 0) );
  vbox->pack_start (*hbox, TRUE, TRUE, 5);
  
  vbox2 = manage( new Gtk_VBox (FALSE, 0) );
  hbox->pack_start (*vbox2, TRUE, TRUE, 5);
  
  label = manage( new Gtk_Label ("Day :", 0, 0.5) );
  vbox2->pack_start (*label, FALSE, TRUE, 0);
  
  adj = manage( new Gtk_Adjustment (1.0, 1.0, 31.0, 1.0, 5.0, 0.0) );
  spinner = manage( new Gtk_SpinButton (*adj, 0, 0) );
  spinner->set_wrap (TRUE);
  spinner->set_shadow_type (GTK_SHADOW_OUT);
  vbox2->pack_start (*spinner, FALSE, TRUE, 0);
  
  vbox2 = manage( new Gtk_VBox (FALSE, 0) );
  hbox->pack_start (*vbox2, TRUE, TRUE, 5);
  
  label = manage( new Gtk_Label ("Month :", 0, 0.5) );
  vbox2->pack_start (*label, FALSE, TRUE, 0);
  
  adj = manage( new Gtk_Adjustment (1.0, 1.0, 12.0, 1.0, 5.0, 0.0) );
  spinner = manage( new Gtk_SpinButton (*adj, 0, 0) );
  spinner->set_wrap (TRUE);
  spinner->set_shadow_type (GTK_SHADOW_ETCHED_IN);
  vbox2->pack_start (*spinner, FALSE, TRUE, 0);
  
  vbox2 = manage( new Gtk_VBox (FALSE, 0) );
  hbox->pack_start (*vbox2, TRUE, TRUE, 5);
  
  label = manage( new Gtk_Label ("Year :", 0, 0.5) );
  vbox2->pack_start (*label, FALSE, TRUE, 0);
  
  adj = manage( new Gtk_Adjustment (1998.0, 0.0, 2100.0, 1.0, 100.0, 0.0) );
  spinner = manage( new Gtk_SpinButton (*adj, 0, 0) );
  spinner->set_wrap (FALSE);
  spinner->set_shadow_type (GTK_SHADOW_IN);
  spinner->set_usize (55, 0);
  vbox2->pack_start (*spinner, FALSE, TRUE, 0);
  
  frame = manage( new Gtk_Frame ("Accelerated") );
  main_vbox->pack_start (*frame, TRUE, TRUE, 0);
  
  vbox = manage( new Gtk_VBox(FALSE, 0) );
  vbox->set_border_width (5);
  frame->add (*vbox);
  
  hbox = manage( new Gtk_HBox (FALSE, 0) );
  vbox->pack_start (*hbox, FALSE, TRUE, 5);
  
  vbox2 = manage( new Gtk_VBox (FALSE, 0) );
  hbox->pack_start (*vbox2, TRUE, TRUE, 5);
  
  label = manage( new Gtk_Label ("Value :", 0, 0.5) );
  vbox2->pack_start (*label, FALSE, TRUE, 0);
  
  adj = manage( new Gtk_Adjustment (0.0, -10000.0, 10000.0,
					      0.5, 100.0, 0.0) );
  spinner1 = manage( new Gtk_SpinButton (*adj, 1.0, 2) );
  spinner1->set_wrap (TRUE);
  spinner1->set_usize (100, 0);
  vbox2->pack_start (*spinner1, FALSE, TRUE, 0);
  
  vbox2 = manage( new Gtk_VBox (FALSE, 0) );
  hbox->pack_start (*vbox2, TRUE, TRUE, 5);
  
  label = manage( new Gtk_Label ("Digits :", 0, 0.5) );
  vbox2->pack_start (*label, FALSE, TRUE, 0);
  
  adj = manage( new Gtk_Adjustment (2, 1, 5, 1, 1, 0) );

  spinner2 = manage( new Gtk_SpinButton (*adj, 0.0, 0) );
  spinner2->set_wrap (TRUE);
  adj->value_changed.connect(bind(slot(this, &AppWindow::change_digits),spinner2));
  vbox2->pack_start (*spinner2, FALSE, TRUE, 0);
  
  hbox = manage( new Gtk_HBox (FALSE, 0) );
  vbox->pack_start (*hbox, FALSE, TRUE, 5);
  
  checkbutton = manage( new ToggleSnap (spinner, "Snap to 0.5-ticks"));
  vbox->pack_start (*checkbutton, TRUE, TRUE, 0);
  checkbutton->set_active (TRUE);
  
  checkbutton = manage( new ToggleNumeric (spinner, "Numeric only input mode") );
  vbox->pack_start ( *checkbutton, TRUE, TRUE, 0);
  checkbutton->set_active (TRUE);
  
  val_label = manage( new Gtk_Label ("") );
  
  hbox = manage( new Gtk_HBox (FALSE, 0) );
  vbox->pack_start (*hbox, FALSE, TRUE, 5);

  button = manage( new Gtk_Button ("Value as Int") );
  button->clicked.connect(bind(slot(this,&AppWindow::get_value),1));
  hbox->pack_start (*button, TRUE, TRUE, 5);
  
  button = manage( new Gtk_Button ("Value as Float") );
  button->clicked.connect(bind(slot(this,&AppWindow::get_value),2));
  hbox->pack_start (*button, TRUE, TRUE, 5);
  
  vbox->pack_start (*val_label, TRUE, TRUE, 0);
  val_label->set_text ("0");
  
  hbox = manage( new Gtk_HBox (FALSE, 0));
  main_vbox->pack_start (*hbox, FALSE, TRUE, 0);
  
  button = manage( new Gtk_Button ("Close") );
  button->clicked.connect(Gtk_Main::quit.slot());
  hbox->pack_start (*button, TRUE, TRUE, 5);

  show_all ();
}

AppWindow::~AppWindow() {}

int main( int   argc,
          char *argv[] )
{
  /* Initialise GTK */
  Gtk_Main kit(&argc, &argv);
    
  /* Create a new window */
  AppWindow app;
    
  /* Enter the event loop */
  Gtk_Main::run ();
    
  return(0);
} 

