// -*- c++ -*-
//  Generated by gtkmmproc from ./../app.gen_h -- DO NOT MODIFY!
#ifndef _GNOMEMM_APP_H
#define _GNOMEMM_APP_H

// -*- C++ -*-
/* $Id: app.gen_h,v 1.46 1999/11/21 09:36:07 glaurent Exp $ */

/* app.gen_h, app.h for gnome--
 *
 * Copyright (C) 1998 EMC Capital Management Inc.
 * Developed by Havoc Pennington <hp@pobox.com>
 *
 * Copyright (C) 1999 The Gtk-- Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <vector>
#include <gtk--/window.h>
#include <gtk--/statusbar.h>
#include <gtk--/menushell.h>
#include <gnome--/dock.h>
#include <gnome--/dialog.h>
#include <gnome--/appbar.h>
#include <libgnome/gnome-i18n.h>
#include <libgnomeui/gnome-app.h>
#include <libgnomeui/gnome-app-helper.h>
#include <libgnomeui/gnome-app-util.h>

class Gtk_MenuBar;
class Gtk_Toolbar;
class Gnome_DockItem;
class Gnome_Dock;
class Gnome_App;
class Gnome_UIInfoArray;

// Gnome_UIInfo classes
//
class Gnome_UIInfo;
typedef vector<Gnome_UIInfo> Gnome_UIInfoTree;

class Gnome_UIInfo : public GnomeUIInfo
{
  friend class Gnome_App;
  friend class Gnome_UIInfoArray;

public:
  Gnome_UIInfo(GnomeUIInfoType type = GNOME_APP_UI_ENDOFINFO);
  Gnome_UIInfo(GnomeUIInfoType type,
	       Gnome_UIInfoTree &subtree);
  Gnome_UIInfo(GnomeUIInfoType type,
	       Slot0<void> callback);

  Gnome_UIInfo(const Gnome_UIInfo &u);

  virtual ~Gnome_UIInfo();

  void set(const GnomeUIInfo&);
  void copyTo(GnomeUIInfo&);

  string get_label() { return label; }
  void set_label(const string &label);

  string get_hint() { return hint; }
  void set_hint(const string &hint);

protected:
  void init(GnomeUIInfoType type);

  Gtk_Widget* get_widget();

  virtual void do_connect();

  //  don't want callback data :
  //   Gnome_UIInfo(Foo,slot(&myfunc));
  // want callback data :
  //   Gnome_UIInfo(Foo,bind(slot(&myfunc),data)); <= data is stored in slot

  Slot0<void> callback_;
  Gnome_UIInfoTree *subtree_;
};

////////////////////////////// Gnome_UIInfoArray
//
// Convert a vector of Gnome_UIInfo into a GnomeUIInfo[] (complete
// with subtrees), and fumble with the created widgets

class Gnome_UIInfoArray
{
public:
  Gnome_UIInfoArray(Gnome_UIInfoTree &v, bool doConnect = true);
  ~Gnome_UIInfoArray();
  GnomeUIInfo* gtkobj() { return uiinfo_; }

private:
  bool doConnect_; // whether we connect() the Gnome_UIInfo widgets to
 // their respective slots

  GnomeUIInfo *uiinfo_; // the resulting GnomeUIInfo array
  Gnome_UIInfoTree &v_; // the reference Gnome_UIInfoTree
  vector<Gnome_UIInfoArray*> subtrees_; // subtrees, if some Gnome_UIInfo elements have one

};


////////////////////////////// Items

class Gnome_UIItem : public Gnome_UIInfo
{
protected:
  // ctor for children classes only
  Gnome_UIItem(Slot0<void> callback)
    : Gnome_UIInfo(GNOME_APP_UI_ITEM, callback) {};

public:
  Gnome_UIItem(const string &label,
	       const string &tooltip,
	       Slot0<void> callback,
	       const char *const xpmData = 0);
};

class Gnome_UIItemStock : public Gnome_UIItem
{
public:
  Gnome_UIItemStock(const string &label,
		    const string &tooltip,
		    Slot0<void> callback,
		    const char *const stockId);
};

class Gnome_UIItemNone : public Gnome_UIItem
{
public:
  Gnome_UIItemNone(const string &label,
		   const string &tooltip,
		   Slot0<void> callback);
};

////////////////////////////// ToggleItem

class Gnome_UIToggleItem : public Gnome_UIInfo
{
public:
  Gnome_UIToggleItem() {};
  Gnome_UIToggleItem(const string &label,
		     const string &tooltip,
		     Slot0<void> callback,
		     const char *const xpmData);
};

////////////////////////////// Radio item

class Gnome_UIRadioList : public Gnome_UIInfo
{
public:
  Gnome_UIRadioList(Gnome_UIInfoTree &list);
};

class Gnome_UIRadioItem : public Gnome_UIItem
{
public:
  Gnome_UIRadioItem(const string &label,
		    const string &tooltip,
		    Slot0<void> callback,
		    const char *const xpmData = 0) :
    Gnome_UIItem(label, tooltip, callback, xpmData) {}
};

////////////////////////////// Subtrees

class Gnome_UISubtree : public Gnome_UIInfo
{
public:
  Gnome_UISubtree(const string &label,
		  Gnome_UIInfoTree &tree);

  Gnome_UISubtree(const string &label,
		  const string &hint,
		  Gnome_UIInfoTree &tree);
};

class Gnome_UISubtreeStock : public Gnome_UIInfo
{
public:
  Gnome_UISubtreeStock(const string &label,
		       Gnome_UIInfoTree &tree,
		       const char *const stockId);

  Gnome_UISubtreeStock(Gnome_UIInfoTree &tree);
};

////////////////////////////// Misc.

class Gnome_UISeparator : public Gnome_UIInfo
{
public:
  Gnome_UISeparator() : Gnome_UIInfo(GNOME_APP_UI_SEPARATOR) {};
};

class Gnome_UIHelp : public Gnome_UIInfo
{
public:
  Gnome_UIHelp(const string &appName);
};

class Gnome_UIEndOfInfo : public Gnome_UIInfo
{
public:
  Gnome_UIEndOfInfo() : Gnome_UIInfo(GNOME_APP_UI_ENDOFINFO) {};
};

////////////////////////////// Menu Items

class Gnome_UIItemConfigurable : public Gnome_UIItem
{
protected:
  Gnome_UIItemConfigurable(const string &label,
			   const string &tooltip,
			   Slot0<void> callback)
    : Gnome_UIItem(label, tooltip, callback) {}

public:
  Gnome_UIItemConfigurable(Slot0<void> callback)
    : Gnome_UIItem(callback) {}
};

namespace Gnome_Menu_Helpers
{

  class Menu : public Gnome_UISubtreeStock
  {
  public:
    Menu(const string &label, Gnome_UIInfoTree &tree);
  };

  ///////////// The 'File' menu.
  namespace Menus
  {
    class File : public Menu
    {
    public:
      File(Gnome_UIInfoTree &tree) :
	Menu(N_("_File"), tree) {}
    };

    class Edit : public Menu
    {
    public:
      Edit(Gnome_UIInfoTree &tree) :
	Menu(N_("_Edit"), tree) {}
    };

    class Settings : public Menu
    {
    public:
      Settings(Gnome_UIInfoTree &tree) :
	Menu(N_("_Settings"), tree) {}
    };

    class Files : public Menu
    {
    public:
      Files(Gnome_UIInfoTree &tree) :
	Menu(N_("Fi_les"), tree) {}
    };
    class Windows : public Menu
    {
    public:
      Windows(Gnome_UIInfoTree &tree) :
	Menu(N_("_Windows"), tree) {}
    };

    class Help : public Menu
    {
    public:
      Help(Gnome_UIInfoTree &tree) :
	Menu(N_("_Help"), tree) {}
    };
  }

  //////// Menu items

  namespace MenuItems
  {
    /// 'File' menu items
    class New : public Gnome_UIItemConfigurable
    {
    public:
      New(const string &label,
	  const string &tip,
	  Slot0<void> callback);
    };

    class NewSubtree : public Gnome_UISubtreeStock
    {
    public:
      NewSubtree(Gnome_UIInfoTree &tree);
    };

    class Open : public Gnome_UIItemConfigurable
    {
    public:
      Open(Slot0<void> callback);
    };

    class Save : public Gnome_UIItemConfigurable
    {
    public:
      Save(Slot0<void> callback);
    };

    class SaveAs : public Gnome_UIItemConfigurable
    {
    public:
      SaveAs(Slot0<void> callback);
    };

    class Revert : public Gnome_UIItemConfigurable
    {
    public:
      Revert(Slot0<void> callback);
    };

    class Print : public Gnome_UIItemConfigurable
    {
    public:
      Print(Slot0<void> callback);
    };

    class PrintSetup : public Gnome_UIItemConfigurable
    {
    public:
      PrintSetup(Slot0<void> callback);
    };

    class Close : public Gnome_UIItemConfigurable
    {
    public:
      Close(Slot0<void> callback);
    };

    class Exit : public Gnome_UIItemConfigurable
    {
    public:
      Exit(Slot0<void> callback);
    };

    /// 'Edit' menu items

    class Cut : public Gnome_UIItemConfigurable
    {
    public:
      Cut(Slot0<void> callback);
    };

    class Copy : public Gnome_UIItemConfigurable
    {
    public:
      Copy(Slot0<void> callback);
    };

    class Paste : public Gnome_UIItemConfigurable
    {
    public:
      Paste(Slot0<void> callback);
    };

    class SelectAll : public Gnome_UIItemConfigurable
    {
    public:
      SelectAll(Slot0<void> callback);
    };

    class Clear : public Gnome_UIItemConfigurable
    {
    public:
      Clear(Slot0<void> callback);
    };

    class Undo : public Gnome_UIItemConfigurable
    {
    public:
      Undo(Slot0<void> callback);
    };

    class Redo : public Gnome_UIItemConfigurable
    {
    public:
      Redo(Slot0<void> callback);
    };

    class Find : public Gnome_UIItemConfigurable
    {
    public:
      Find(Slot0<void> callback);
    };

    class FindAgain : public Gnome_UIItemConfigurable
    {
    public:
      FindAgain(Slot0<void> callback);
    };

    class Replace : public Gnome_UIItemConfigurable
    {
    public:
      Replace(Slot0<void> callback);
    };

    class Properties : public Gnome_UIItemConfigurable
    {
    public:
      Properties(Slot0<void> callback);
    };


    /// 'Settings' menu item

    class Preferences : public Gnome_UIItemConfigurable
    {
    public:
      Preferences(Slot0<void> callback);
    };


    /// 'Windows' menu items

    class NewWindow : public Gnome_UIItemConfigurable
    {
    public:
      NewWindow(Slot0<void> callback);
    };

    class CloseWindow : public Gnome_UIItemConfigurable
    {
    public:
      CloseWindow(Slot0<void> callback);
    };


    /// 'Help' menu items.

    class About : public Gnome_UIItemConfigurable
    {
    public:
      About(Slot0<void> callback);
    };

  }

}

//////////////////////////////////////////////////////////////////////////////

class Gnome_App;
class Gnome_App_Class;
template <> struct Gtk_Wrap<GnomeApp> {typedef Gnome_App CppType;};
class Gnome_App : public Gtk_Window
{

public:
  typedef Gnome_App          CppObjectType;
  typedef Gnome_App_Class    CppClassType;
  typedef GnomeApp           BaseObjectType;
  typedef GnomeAppClass      BaseClassType;

private:
  friend CppClassType;
  static CppClassType app_class;

  Gnome_App(const Gnome_App&);
  Gnome_App& operator=(const Gnome_App&); // not implemented

protected:
  void   initialize_class();
  void*  get_parent_class() { return static_cast<void*>(parent_class_); }

  static void    init_parent_class()
    { Gtk_Window::get_type(); }
  explicit Gnome_App(GnomeApp *castitem);

public:
  static GtkType get_type();
  GnomeApp* gtkobj()             { return GNOME_APP(gtkobject); }
  const GnomeApp* gtkobj() const { return GNOME_APP(gtkobject); }
  static bool isA(Gtk_Object *checkcast);

  // Hook for proxies
  static const char* const signal_names[];

  virtual ~Gnome_App();

private:

public:
  Gnome_App();



private:
  //: add() is not applicable
  //- Because a Gnome_App is a compound widget, you would
  //- only use the set_content() function.
  //   void add(Gtk_Widget*);
  //   void add(Gtk_Widget&);

public:

  Gnome_App                     (const string &appname,
				 const string &title);

  // Functions from gnome-app.h
  void set_menus                (const Gtk_MenuBar& menubar);

  void set_toolbar              (const Gtk_Toolbar& toolbar);

  void set_statusbar            (const Gtk_Widget&    statusbar);
  void set_statusbar_custom     (const Gtk_Container& container,
				 const Gtk_Widget&    statusbar);

  void set_contents             (const Gtk_Widget& contents);

  void add_toolbar              (const Gtk_Toolbar &toolbar,
				 const string &name,
				 GnomeDockItemBehavior behavior,
				 GnomeDockPlacement placement,
				 gint band_num,
				 gint band_position,
				 gint offset);

  void add_docked               (const Gtk_Widget &widget,
				 const string &name,
				 GnomeDockItemBehavior behavior,
				 GnomeDockPlacement placement,
				 gint band_num,
				 gint band_position,
				 gint offset);

  void add_dock_item            (const Gnome_DockItem &item,
				 GnomeDockPlacement placement,
				 gint band_num,
				 gint band_position,
				 gint offset);


  void enable_layout_config(gboolean enable);

  Gnome_DockItem* get_dock_item_by_name (const string name);

  Gnome_Dock* get_dock() const;


  // From gnome-app-helper.h - have to rewrite all this
  static void fill_menu         (Gtk_MenuShell &menu_shell,
				 Gnome_UIInfoTree &menuinfo,
				 Gtk_AccelGroup &accel_group,
				 bool uline_accels,
				 gint pos);

  void create_menus             (Gnome_UIInfoTree &menuinfo);

  void create_menus_with_data   (Gnome_UIInfoTree &menuinfo,
				 gpointer data);

  void create_toolbar           (Gnome_UIInfoTree &toolbarinfo);

  void create_toolbar_with_data (Gnome_UIInfoTree &toolbarinfo,
				 gpointer data);




  static Gtk_Widget* find_menu_pos(const Gtk_Widget& parent,const string& path,gint* pos);


  void remove_menus(const string& path,gint items);

  void insert_menus             (const string &path,
				 Gnome_UIInfoTree &menuinfo);

  void insert_menus_with_data   (const string &path,
				 Gnome_UIInfoTree &menuinfo,
				 gpointer data);

  static void install_appbar_menu_hints    (const Gnome_AppBar &app,
					    Gnome_UIInfoTree &menuinfo);
  static void install_statusbar_menu_hints (const Gtk_Statusbar &bar,
					    Gnome_UIInfoTree &menuinfo);
  void install_menu_hints                  (Gnome_UIInfoTree &menuinfo);


  // From gnome-app-util.h

  // - WARNING : These methods can return NULL

  Gnome_Dialog* message(const string& message);


  void flash(const string& message);


  Gnome_Dialog* error(const string& error);


  Gnome_Dialog* warning(const string& warning);

  // Sorry, I can't think of any way to specify a method as a
  // callback, short of rewriting the damn thing. We might just do
  // that someday - GL




  Gnome_Dialog* question(const string& question,GnomeReplyCallback callback,gpointer data);





  Gnome_Dialog* question_modal(const string& question,GnomeReplyCallback callback,gpointer data);





  Gnome_Dialog* ok_cancel(const string& message,GnomeReplyCallback callback,gpointer data);





  Gnome_Dialog* ok_cancel_modal(const string& message,GnomeReplyCallback callback,gpointer data);





  Gnome_Dialog* request_string(const string& prompt,GnomeStringCallback callback,gpointer data);





  Gnome_Dialog* request_password(const string& prompt,GnomeStringCallback callback,gpointer data);

  GnomeAppProgressKey progress_timeout(const string& description,guint32 interval,GnomeAppProgressFunc percentage_cb,GnomeAppProgressCancelFunc cancel_cb,gpointer data);

  GnomeAppProgressKey progress_manual(const string& description,GnomeAppProgressCancelFunc cancel_cb,gpointer data);


  static void gnome_app_set_progress(GnomeAppProgressKey key,gdouble percent);


  static void gnome_app_progress_done(GnomeAppProgressKey key);

public:
#ifndef GTKMM_CXX_GAUB
  union
    {
#endif
      CppObjectType *app_self;
#ifndef GTKMM_CXX_GAUB
    };
#endif

protected:
  // impl functions

};

#endif
