// -*- c++ -*-
//  Generated by gtkmmproc from ./../dialog.gen_h -- DO NOT MODIFY!
#ifndef _GNOMEMM_DIALOG_H
#define _GNOMEMM_DIALOG_H

/* $Id: dialog.gen_h,v 1.34 1999/09/30 00:20:23 plerner Exp $ */

/* dialog.gen_h, dialog.h
 *
 * Copyright (C) 1998 EMC Capital Management Inc.
 * Developed by Havoc Pennington <hp@pobox.com>
 *
 * Copyright (C) 1999 The Gtk-- Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gtk--/window.h>
#include <gtk--/box.h>
#include <libgnomeui/gnome-dialog.h>
#include <libgnomeui/gnome-dialog-util.h>

class Gtk_Editable;

class Gnome_Dialog;
class Gnome_Dialog_Class;
template <> struct Gtk_Wrap<GnomeDialog> {typedef Gnome_Dialog CppType;};
class Gnome_Dialog : public Gtk_Window
{

public:
  typedef Gnome_Dialog          CppObjectType;
  typedef Gnome_Dialog_Class    CppClassType;
  typedef GnomeDialog           BaseObjectType;
  typedef GnomeDialogClass      BaseClassType;

private:
  friend CppClassType;
  static CppClassType dialog_class;

  Gnome_Dialog(const Gnome_Dialog&);
  Gnome_Dialog& operator=(const Gnome_Dialog&); // not implemented

protected:
  void   initialize_class();
  void*  get_parent_class() { return static_cast<void*>(parent_class_); }

  static void    init_parent_class()
    { Gtk_Window::get_type(); }
  explicit Gnome_Dialog(GnomeDialog *castitem);

public:
  static GtkType get_type();
  GnomeDialog* gtkobj()             { return GNOME_DIALOG(gtkobject); }
  const GnomeDialog* gtkobj() const { return GNOME_DIALOG(gtkobject); }
  static bool isA(Gtk_Object *checkcast);

  // Hook for proxies
  static const char* const signal_names[];

  virtual ~Gnome_Dialog();

private:

public:
  Gnome_Dialog();



  Gnome_Dialog(const string &title,
	       const Gtk_SArray &buttons);


  Gtk_VBox* get_vbox() const;

  // Don't know how to implement these in Gtk--, they aren't
  //  very important anyway. Use the clicked signal.
  //  void button_connect ???;
  //  void button_connect_object ???;

  void set_parent (const Gtk_Window &parent);

  // Will wrap those only if there's a request for it - GL
  // gnome_dialog_button_connect()
  // gnome_dialog_button_connect_object()

  //: Make the dialog temporarily modal until a button
  //:  is clicked. Then return button number or -1 for none.

  gint run();


  gint run_and_close();

  //: Set the default button

  void set_default(gint button);

  //: Set button sensitivity

  void set_sensitive(gint button,gboolean setting);

  //: Accelerator for a button

  void set_accelerator(gint button,const guchar accelerator_key,guint8 accelerator_mods);

  //: Close the dialog, either by hiding or destroying

  void cause_close();

  //: Whether the dialog does delete_self() or just hide() on close.

  void close_hides(gboolean just_hide);

  //: Whether any button click should trigger a close.

  void set_close(gboolean click_closes);


  void append_button_with_pixmap(const string& name,const string& pixmap);

  // Will wrap those only if there's a request for it - GL
  // gnome_dialog_append_buttons()
  // gnome_dialog_append_button()
  // gnome_dialog_append_buttonsv()
  // gnome_dialog_append_buttons_with_pixmaps()


  //: Utility stuff

  //: A little OK box

  static Gnome_Dialog* ok_dialog(const string& message);



  static Gnome_Dialog* ok_dialog_parented(const string& message,Gtk_Window& parent);
  //: Operation failed fatally. In an OK dialog.

  static Gnome_Dialog* error_dialog(const string& error);



  static Gnome_Dialog* error_dialog_parented(const string& error,Gtk_Window& parent);
  //: Just a warning

  static Gnome_Dialog* warning_dialog(const string& warning);



  static Gnome_Dialog* warning_dialog_parented(const string& warning,Gtk_Window& parent);

  //: Ask a yes or no question, and call the callback when it's answered.
  //: (*sigh*. The usual C-style callback which you can't get rid of... - GL)

  static Gtk_Widget* question_dialog(const string& message,GnomeReplyCallback callback,gpointer data);

  static Gtk_Widget* question_dialog_parented(const string& message,GnomeReplyCallback callback,gpointer data,const Gtk_Window& parent);

  static Gtk_Widget* question_dialog_modal(const string& message,GnomeReplyCallback callback,gpointer data);

  static Gtk_Widget* question_dialog_modal_parented(const string& message,GnomeReplyCallback callback,gpointer data,const Gtk_Window& parent);

  static Gtk_Widget* ok_cancel_dialog(const string& message,GnomeReplyCallback callback,gpointer data);

  static Gtk_Widget* ok_cancel_dialog_parented(const string& message,GnomeReplyCallback callback,gpointer data,const Gtk_Window& parent);

  static Gtk_Widget* ok_cancel_dialog_modal(const string& message,GnomeReplyCallback callback,gpointer data);

  static Gtk_Widget* ok_cancel_dialog_modal_parented(const string& message,GnomeReplyCallback callback,gpointer data,const Gtk_Window& parent);

  static Gtk_Widget* request_dialog(bool password,const string& prompt,const string& default_text,const guint16 max_length,GnomeStringCallback callback,gpointer data,const Gtk_Window& parent);


  //: Whether pushing return in this editable should
  //:  activate the default button.
  void editable_enters(Gtk_Editable* e);

  //: gint is the button number.



  //: For Gtk+, the return value of the close handler allows or blocks
  //:  the close; for gtk--, it is basically irrelevant (just override the
  //:  default close_impl to block the close)

public:
#ifndef GTKMM_CXX_GAUB
  union
    {
#endif
      CppObjectType *dialog_self;
      ProxySignal1<void,gint,CppObjectType,BaseObjectType,0> clicked;
      ProxySignal0<gboolean,CppObjectType,BaseObjectType,1> close;
#ifndef GTKMM_CXX_GAUB
    };
#endif

protected:
  // impl functions
    virtual void clicked_impl(gint p0);
    virtual gboolean close_impl();

};

#endif
