// -*- c++ -*-
//  Generated by gtkmmproc from ./../arrow.gen_h -- DO NOT MODIFY!
#ifndef _GTKMM_ARROW_H
#define _GTKMM_ARROW_H

/* $Id: arrow.gen_h,v 1.31 1999/09/12 10:16:22 glaurent Exp $ */

/* arrow.h
 *
 * Copyright (C) 1998-1999 The Gtk-- Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gtk--/misc.h>
#include <gtk/gtkarrow.h>
class Gtk_Arrow;
class Gtk_Arrow_Class;
template <> struct Gtk_Wrap<GtkArrow> {typedef Gtk_Arrow CppType;};
//: Arrow widget
//- This is intended for use where a directional arrow (in one of the
//- four cardinal directions) is desired. As such, it has very limited
//- functionality and basically only draws itself in a particular
//- direction and
//- with a particular shadow type.
//-
//- Gtk_Arrow will fill any space alloted to it, but since it is inherited
//- from {\class Gtk_Misc}, it can be padded and/or aligned, to fill exactly
//- the space the programmer desires.
class Gtk_Arrow : public Gtk_Misc {

public:
  typedef Gtk_Arrow          CppObjectType;
  typedef Gtk_Arrow_Class    CppClassType;
  typedef GtkArrow           BaseObjectType;
  typedef GtkArrowClass      BaseClassType;

private:
  friend CppClassType;
  static CppClassType arrow_class;

  Gtk_Arrow(const Gtk_Arrow&);
  Gtk_Arrow& operator=(const Gtk_Arrow&); // not implemented

protected:
  void   initialize_class();
  void*  get_parent_class() { return static_cast<void*>(parent_class_); }

  static void    init_parent_class()
    { Gtk_Misc::get_type(); }
  explicit Gtk_Arrow(GtkArrow *castitem);

public:
  static GtkType get_type();
  GtkArrow* gtkobj()             { return GTK_ARROW(gtkobject); }
  const GtkArrow* gtkobj() const { return GTK_ARROW(gtkobject); }
  static bool isA(Gtk_Object *checkcast);

  // Hook for proxies
  static const char* const signal_names[];

  virtual ~Gtk_Arrow();

private:

public:


  //: Creates an arrow.
  //- Must specify the direction with {arrow_type} and the shadow with
  //- {shadow_type}.
  Gtk_Arrow(GtkArrowType arrow_type,
	    GtkShadowType shadow_type);



  //: Changes the direction and shadow of an arrow.



  void set(GtkArrowType arrow_type,GtkShadowType shadow_type);

public:
#ifndef GTKMM_CXX_GAUB
  union
    {
#endif
      CppObjectType *arrow_self;
#ifndef GTKMM_CXX_GAUB
    };
#endif

protected:
  // impl functions

};



//+ PROPERTIES(Gtk_Arrow)
//. name: arrow_type
//. type: gint16
//. get:
//. set: {set()}
//. desc: Specifies which direction the arrow will point.
//.
//. Possible Values: {\enum GTK_ARROW_UP}, {\enum GTK_ARROW_DOWN},
//.  {\enum  GTK_ARROW_LEFT}, {\enum GTK_ARROW_RIGHT}

//. name: shadow_type
//. type: gint16
//. get:
//. set: {set()}
//. desc: Specifies which direction the arrow will point.
//.
//. Possible Values:
//.   {\enum GTK_SHADOW_IN}, {\enum GTK_SHADOW_OUT}

#endif
