// -*- c++ -*-
//  Generated by gtkmmproc from ./../base.gen_h -- DO NOT MODIFY!
#ifndef _GTKMM_BASE_H
#define _GTKMM_BASE_H

/* $Id: base.gen_h,v 1.86 1999/11/05 18:50:34 kenelson Exp $ */

/* base.h
 *
 * Copyright (C) 1998-1999 The Gtk-- Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <string>
//#include <list>
//#include <vector>

#include <gtk--config.h>
#include <gdk--.h>
#include <gtk--/proxy.h>
#include <gtk--/marshal.h>

#ifdef GTKMM_CXX_HAVE_AUTO_PTR
#include <memory>
#endif


/* This aint pretty, but I don't know a better way to make
   sure things work when the stl classes are defined in a namespace */

#ifdef GTKMM_CXX_HAVE_NAMESPACES
namespace std{}
using namespace std;
#endif /* GTKMM_CXX_HAVE_NAMESPACES */

// Gtk-- Base and other utility classes
#define GTK_VERSION_GT(major,minor) ((GTK_MAJOR_VERSION>major)||(GTK_MAJOR_VERSION==major)&&(GTK_MINOR_VERSION>minor))
#define GTK_VERSION_GE(major,minor) ((GTK_MAJOR_VERSION>major)||(GTK_MAJOR_VERSION==major)&&(GTK_MINOR_VERSION>=minor))
#define GTK_VERSION_EQ(major,minor) ((GTK_MAJOR_VERSION==major)&&(GTK_MINOR_VERSION==minor))
#define GTK_VERSION_NE(major,minor) ((GTK_MAJOR_VERSION!=major)||(GTK_MINOR_VERSION!=minor))
#define GTK_VERSION_LE(major,minor) ((GTK_MAJOR_VERSION<major)||(GTK_MAJOR_VERSION==major)&&(GTK_MINOR_VERSION<=minor))
#define GTK_VERSION_LT(major,minor) ((GTK_MAJOR_VERSION<major)||(GTK_MAJOR_VERSION==major)&&(GTK_MINOR_VERSION<minor))

#define GTK_VERSION_GT_MICRO(major,minor,micro) \
  ((GTK_MAJOR_VERSION>major)|| \
  (GTK_MAJOR_VERSION==major)&&(GTK_MINOR_VERSION>minor)||\
  (GTK_MAJOR_VERSION==major)&&(GTK_MINOR_VERSION==minor)&&(GTK_MICRO_VERSION>minor))


/********************************************************************/

//Hook for faster data access
extern GQuark gtkmm_quark;

/* Translating API */

// hook for C => C++ translation
template <class C> struct Gtk_Wrap {typedef C CppType;};

struct _GtkObject;
class Gtk_Object;
typedef Gtk_Object* (*Gtk_Wrap_Func)(_GtkObject*);

// Generates an automatic wrapper for a gtkclass.
Gtk_Object* gtkmm_wrap_auto(_GtkObject*);

// Register a new type for auto allocation.
void gtkmm_wrap_register(const string&,Gtk_Wrap_Func);

// Request a specific wrapper for an object.
template <class Cpp>
Cpp* gtkmm_wrap_new(typename Cpp::BaseObjectType* o)
  {
   return (typename Cpp::CppClassType::wrap_new(o));
  }

// interface to gtk--
template <class C>
typename Gtk_Wrap<C>::CppType* gtkmm_wrap(C* o)
  {
    return dynamic_cast<typename Gtk_Wrap<C>::CppType*>(gtkmm_wrap_auto((GtkObject*)(o)));
  }

/********************************************************************/

/* this class is a required stub implementation which does nothing! */
struct GtkBase { };
struct GtkBaseClass { };

struct Gtk_Base_Class
  {
    static void class_init_function( GtkBaseClass *b)
      {(void)b;}
  };

//: This is an empty class needed by our code generator
class Gtk_Base : public virtual SigC::Object
  {
    public:
      typedef Gtk_Base          CppObjectType;
      typedef Gtk_Base_Class    CppClassType;

    protected:
      static int get_type() {return 0;}
  };

/********************************************************************/

//: Input filter to screen out NULL inputs
// This class should not be used outside Gtk-- parameter lists.
// It is intended to be used whereever a string is passed
// as an input that may be 0.  (Gtk-- internal)
class gtkmm_string : public string {
  bool null_;
public:
  explicit gtkmm_string();
  gtkmm_string(string str);
  // lets not use "NULL" in gtk--. 0 is much more portable in c++.
  gtkmm_string(const char *s);
  ~gtkmm_string();

  // this function should be used in place of c_str
  // if NULL is a valid value.
  const char * gc_str() const;

  // returns 1 if this was created from a NULL pointer
  int null()  const
    {return null_;}
};

/********************************************************************/

template <class T> struct G_List_Iterator;
template <class T> struct G_List_ConstIterator;
template <class T> struct G_List_ReverseIterator;

// Most of these methods in the non-template classes needs to be moved
// to implementation.

// GList if we own list
class G_ListImpl
{
  GList *list_;
  G_ListImpl(const G_ListImpl&);
public:
  G_ListImpl(): list_(0) {}
  ~G_ListImpl()         {g_list_free(list_);}

  GList* const& list() const {return list_;}
  //GList*& list() {return list_;} // is it allowed, if we own the list??

  int index_of(gpointer data)
    {return g_list_index(list_,data);}
  int position(GList *pos)
    {return g_list_position(list_,pos);}
  GList* first()
    {return g_list_first(list_);}
  GList* last()
    {return g_list_last(list_);}

  size_t size() const
    { return g_list_length(list_); }
  bool empty() const
    { return size()==0; }

  void reverse()
    {list_=g_list_reverse(list_);}

  GList* insert(GList* pos,gpointer data);

  void remove(gpointer data)
    {list_=g_list_remove(list_,data);}

  GList* erase(GList* pos);

  void clear()
    {
      g_list_free(list_);
      list_=0;
    }
};

// GList wrapper if we don't.  (Don't delete, use a reference)
class G_ListWrap
{
  GList*& list_;
public:
  G_ListWrap(GList*& l)           : list_(l)       {}
  G_ListWrap(const G_ListWrap& l) : list_(l.list_) {}

  GList*& list() {return list_;}
  GList* const& list() const {return list_;}

  int index_of(gpointer data)
    {return g_list_index(list_,data);}
  int position(GList *pos)
    {return g_list_position(list_,pos);}
  GList* first()
    {return g_list_first(list_);}
  GList* last()
    {return g_list_last(list_);}

  size_t size() const
    { return g_list_length(list_); }
  bool empty() const
    { return size()==0; }

  void reverse()
    {list_=g_list_reverse(list_);}

  GList* insert(GList* pos,gpointer data);

  void remove(gpointer data)
    {list_=g_list_remove(list_,data);}

  GList* erase(GList* pos);

  void clear()
    {
      g_list_free(list_);
      list_=0;
    }
};

// This is a C++ style wrapper on the GList (still not yet full featured)
template <class T,class Impl=G_ListImpl>
class G_List
{
public:
  typedef G_List<T,Impl>                         Self;
  typedef G_List_Iterator<T>                     iterator;
  typedef G_List_ConstIterator<iterator>         const_iterator;
  typedef G_List_ReverseIterator<iterator>       reverse_iterator;
  typedef G_List_ReverseIterator<const_iterator> reverse_const_iterator;
  typedef size_t                                 size_type;

private:
  Impl impl;
  G_List(const Self& x);
public:
  G_List()              : impl()  {}
  G_List(const Impl& i) : impl(i) {}
  ~G_List()                       {}

  GList* const& glist() const { return impl.list(); }
  GList* & glist() { return impl.list(); }

  iterator begin()             { return iterator(impl.list(),impl.first()); }
  iterator end()               { return iterator(impl.list(),(GList*)0); }
  const_iterator begin() const { return const_iterator(impl.list(),impl.first()); }
  const_iterator end()   const { return const_iterator(impl.list(),(GList*)0); }
  reverse_iterator rbegin()    { return reverse_const_iterator(end()); }
  reverse_iterator rend()      { return reverse_const_iterator(begin()); }
  reverse_const_iterator rbegin() const { return reverse_const_iterator(end());}
  reverse_const_iterator rend()   const { return reverse_const_iterator(begin());}

  iterator insert(iterator pos,const T& data)
    { return iterator(impl.insert(pos,reinterpret_cast<gpointer&>(data)));}

  iterator erase(iterator pos)
    { return iterator(impl.erase(pos));}
  void remove(const T& data)
    { impl.remove(reinterpret_cast<gpointer&>(data));}
  void clear() {impl.clear();}

  void push_front(const T& data) { insert(begin(), data); }
  void push_back(const T& data)  { insert(end(), data); }
  void pop_front()               { erase(begin()); }
  void pop_back()                { erase(impl.last());}

  void reverse()                 { impl.reverse();}

  size_type size() const         { return impl.size(); }
  bool empty() const             { return impl.empty(); }

};


/********************************************************************/

extern gpointer gtkmm_null_pointer;

template <class T>
struct G_List_Iterator
{
  typedef bidirectional_iterator_tag iterator_category;
  typedef size_t size_type;
  typedef ptrdiff_t difference_type;

  typedef T  value_type;
  typedef T* pointer;
  typedef T& reference;

  GList **head;
  GList *node;

  typedef G_List_Iterator<T> Self;

  G_List_Iterator(GList*& h,GList *n) : head(&h)    ,node(n)      {}
  G_List_Iterator()                   : head(0)     ,node(0)      {}
  G_List_Iterator(const Self& x)      : head(x.head),node(x.node) {}

  bool operator==(const Self& x) const { return node == x.node; }
  bool operator!=(const Self& x) const { return node != x.node; }

  Self&  operator++()
  {
    if (!node)
      node=g_list_first(*head);
    else
      node = g_list_next(node);
    return *this;
  }

  Self operator++(int)
  {
    Self tmp = *this;
    ++*this;
    return tmp;
  }

  Self&  operator--()
  {
    if (!node)
      node=g_list_last(*head);
    else
      node = g_list_previous(node);
    return *this;
  }

  Self operator--(int)
  {
    Self tmp = *this;
    --*this;
    return tmp;
  }

  reference operator*()  const { return reinterpret_cast<T&>((node)?(*node).data:gtkmm_null_pointer); }
  pointer operator -> () const { return &operator*(); }
};

template <class T>
struct G_SList_Iterator
{
  typedef forward_iterator_tag iterator_category;
  typedef size_t size_type;
  typedef ptrdiff_t difference_type;

  typedef T  value_type;
  typedef T* pointer;
  typedef T& reference;

  GSList *node;
  typedef G_SList_Iterator<T> Self;

  G_SList_Iterator(GSList *n)     : node(n)      {}
  G_SList_Iterator()              : node(0)      {}
  G_SList_Iterator(const Self& x) : node(x.node) {}

  bool operator==(const Self& x) const { return node == x.node; }
  bool operator!=(const Self& x) const { return node != x.node; }

  Self&  operator++()
  {
    node = g_slist_next(node);
    return *this;
  }

  Self operator++(int)
  {
    Self tmp = *this;
    ++*this;
    return tmp;
  }

  reference operator*()  const { return reinterpret_cast<T&>((node)?(*node).data:gtkmm_null_pointer); }
  pointer operator -> () const { return &operator*(); }
};

// this iterator variation returns interf (wrapped from impl)
//  Equivelency  G_List_Cpp_Iterator<GtkWidget,Gtk_Widget>
//     => list<Gtk_Widget*>::iterator
template<class impl, class interf>
struct G_List_Cpp_Iterator {
  typedef input_iterator_tag iterator_category;
  typedef size_t size_type;
  typedef ptrdiff_t difference_type;

  typedef interf*  value_type;
  typedef interf** pointer;
  typedef interf*& reference;

  typedef G_List_Cpp_Iterator<impl,interf> Self;

  GList **head;
  GList *node;

  bool operator==(const Self& x) const { return node == x.node; }
  bool operator!=(const Self& x) const { return node != x.node; }

  G_List_Cpp_Iterator(GList*& h,GList *n) : head(&h)    ,node(n)      {}
  G_List_Cpp_Iterator()                   : head(0)     ,node(0)      {}
  G_List_Cpp_Iterator(const Self& x)      : head(x.head),node(x.node) {}

  value_type operator*() const
  {
    if (node && node->data)
      return gtkmm_wrap(static_cast<impl*>((*node).data));
    return 0;
  }

  Self&  operator++()
  {
    if (!node)
      node=g_list_first(*head);
    else
      node = g_list_next(node);
    return *this;
  }

  Self operator++(int)
  {
    Self tmp = *this;
    ++*this;
    return tmp;
  }

  Self&  operator--()
  {
    if (!node)
      node=g_list_last(*head);
    else
      node = g_list_previous(node);
    return *this;
  }

  Self operator--(int)
  {
    Self tmp = *this;
    --*this;
    return tmp;
  }

};

template <class B>
struct G_List_ReverseIterator: private B
{
  typedef typename B::iterator_category iterator_category;
  typedef typename B::size_type         size_type;
  typedef typename B::difference_type   difference_type;

  typedef typename B::value_type        value_type;
  typedef typename B::pointer           pointer;
  typedef typename B::reference         reference;

  typedef G_List_ReverseIterator<B>    Self;

  bool operator==(const Self& x) const { return B::operator==(x); }
  bool operator!=(const Self& x) const { return B::operator!=(x); }

  G_List_ReverseIterator(GList*& h,GList *n) : B(h,n) {}
  G_List_ReverseIterator()                   : B()    {}
  G_List_ReverseIterator(const Self& x)      : B(x)   {}
  G_List_ReverseIterator(const B& x)         : B(x)   { --(*this); }

  Self& operator++()   {B::operator--(); return *this;}
  Self& operator--()   {B::operator++(); return *this;}
  Self operator++(int) {Self s=*this; B::operator--(); return s;}
  Self operator--(int) {Self s=*this; B::operator++(); return s;}

  reference operator*()  const { return B::operator*(); }
  pointer operator -> () const { return B::operator->(); }
};

template <class B>
struct G_List_ConstIterator: public B
{
  typedef typename B::iterator_category iterator_category;
  typedef typename B::size_type         size_type;
  typedef typename B::difference_type   difference_type;

  typedef const typename B::value_type  value_type;
  typedef const typename B::pointer     pointer;
  typedef const typename B::reference   reference;

  typedef G_List_ConstIterator<B>    Self;

  bool operator==(const Self& x) const { return B::operator==(x); }
  bool operator!=(const Self& x) const { return B::operator!=(x); }

  G_List_ConstIterator(GList*& h,GList *n) : B(h,n) {}
  G_List_ConstIterator()                   : B()    {}
  G_List_ConstIterator(const Self& x)      : B(x)   {}
  G_List_ConstIterator(const B& x)         : B(x)   {}

  Self& operator++()   {B::operator++(); return *this;}
  Self& operator--()   {B::operator--(); return *this;}
  Self operator++(int) {Self s=*this; B::operator++(); return s;}
  Self operator--(int) {Self s=*this; B::operator--(); return s;}

  reference operator*()  const { return B::operator*(); }
  pointer operator -> () const { return B::operator->(); }
};

// for compatablity
typedef G_List<int> G_IntList;
typedef G_List_Iterator<int> G_IntList_Iterator;

/********************************************************************/

// Converter functions to simplify the list building
template <class T>
inline const char* gtkmm_to_cstring (const T& t)
  { return t; }

template <>
inline const char* gtkmm_to_cstring<string>(const string& t)
  { return t.c_str(); }

template <>
inline const char* gtkmm_to_cstring<gtkmm_string>(const gtkmm_string& t)
  { return t.gc_str(); }



#ifdef GTKMM_CXX_AMBIGUOUS_TEMPLATES
#include <list>
#include <vector>
#endif

// (internal) This is equivelent to a const char**
// This is a converter so you would not declare any of this type.
class Gtk_SArray
{
protected:
  typedef const char* cstring;

  bool owned_;
  cstring *data_;
  size_t size_;

  void a_alloc(size_t size);

  template <class Iterator>
  void a_dup(Iterator b,Iterator e);

public:
  operator const char** () const
  { return data_; }

  Gtk_SArray(const Gtk_SArray& c);

  Gtk_SArray(const char** data);

  size_t size(void) const { return size_; }

#ifndef GTKMM_CXX_AMBIGUOUS_TEMPLATES
  // copy a other containers
  template <class Container>
  Gtk_SArray(const Container& c)
  { a_dup(c.begin(),c.end()); }
#else
  // compiler can't handle template cctor properly.
  Gtk_SArray(const list<string>& c)        { a_dup(c.begin(),c.end()); }
  Gtk_SArray(const vector<string>& c)      { a_dup(c.begin(),c.end()); }
  Gtk_SArray(const list<gtkmm_string>& c)  { a_dup(c.begin(),c.end()); }
  Gtk_SArray(const vector<gtkmm_string>& c){ a_dup(c.begin(),c.end()); }
  Gtk_SArray(const list<const char*>& c)   { a_dup(c.begin(),c.end()); }
  Gtk_SArray(const vector<const char*>& c) { a_dup(c.begin(),c.end()); }
#endif

  // copy a partial container
  template <class Iterator>
  Gtk_SArray(Iterator b,Iterator e):owned_(0)
  { a_dup(b,e); }

  ~Gtk_SArray()
  {if (owned_) delete [] data_;}
};


template <class Iterator>
void Gtk_SArray::a_dup(Iterator b,Iterator e)
{
  Iterator iter;
  size_t i;

  for (iter=b, i=0; iter!=e; ++iter, ++i);
  a_alloc(i);

  for (iter=b, i=0; iter!=e; ++iter, ++i)
    data_[i]=gtkmm_to_cstring(*iter);
}


/********************************************************************/

/* the next one is private - its not inside Gtk_ObjectHandle to make it
   work on more compilers. */
template<class T> struct Gtk_ObjectHandle_ref {
  T *ptr;
  Gtk_ObjectHandle_ref(T *p) : ptr(p) { }
};



//: Convenience class to ease management of "cached" data-members,
//e.g. Gtk-- objects which reflect a gtk object. Kinda like auto_ptr,
//in that it lets you set whether the handled object is "owned" (in
//which case it will be deleted along with the object) or not (it's
//left alone).
//
// See Gtk_Widget::[gs]et_parent() for an example among others. The
// issue is rather complex because there are a lot of different
// cases.
//
// The overall principle of those "cached" data members is to wrap "on
// the fly" the gtk object resulting from a gtk_get_whatever() call
// and store it in the data-member. On the next call, the content of
// the cache is compared with the result of the actual gtk+ query. If
// it is still valid, the cache is returned, otherwise it is deleted
// and recreated.
//
// Things get more complicated when there is also a corresponding
// gtk_set_whatever() call. In this case, we obviously want to replace
// the content of the cache by the argument passed to set(). But in
// this case, the argument does not belong to us therefore, we must
// not destroy it.
//

template <class OBJECT>
class Gtk_ObjectHandle
{
public:
  // ctor's dtors
  explicit Gtk_ObjectHandle( OBJECT* obj=0, bool owned = true)
    : object_(obj), owned_(owned) {}
#ifdef GTKMM_CXX_HAVE_AUTO_PTR
  Gtk_ObjectHandle(auto_ptr<OBJECT> &obj)
    : object_(obj.release()), owned_(true) {}
#endif
  Gtk_ObjectHandle(Gtk_ObjectHandle_ref<OBJECT> ref)
  : object_(ref.ptr) { }
  ~Gtk_ObjectHandle() { if(owned_) delete object_; }
  // accessors
  const OBJECT*     get_object() const { return object_; }
  OBJECT &          operator*() const { return *object_; }
  OBJECT *          operator->() const { return object_; }
  bool              owner() const { return owned_;}
  // manipulators
#ifdef GTKMM_CXX_HAVE_MEMBER_TEMPLATES
  template <class _Tp1> operator Gtk_ObjectHandle_ref<_Tp1>()
    { return Gtk_ObjectHandle_ref<OBJECT>(this->release()); }
#ifdef GTKMM_CXX_HAVE_AUTO_PTR
  template <class _Tp1> operator auto_ptr<_Tp1>()
    { return auto_ptr<_Tp1>(this->release()); }
#endif
  template <class _Tp1> operator Gtk_ObjectHandle<_Tp1>()
    { return Gtk_ObjectHandle<_Tp1>(this->release()); }
#endif
  Gtk_ObjectHandle(const Gtk_ObjectHandle &a)
   : object_(a.release()), owned_(true) {}
  /* a must have ownership to call this, and this object gets
     the ownership */
  Gtk_ObjectHandle& operator=(const Gtk_ObjectHandle &a) {
    if (&a != this) {
      if ((a.object_ != object_) && owned_) {
	delete object_;
      }
      object_=a.release();
      owned_ = true;
    }
    return *this;
  }
  // get() is standard from auto_ptr, we should have one too...
  OBJECT *      get() /* const */ { return object_; }
  OBJECT *      get_object() { return object_;}
  OBJECT *      release() const { g_return_val_if_fail(owned_,0);
		      owned_=false; return object_;
                     }
  void          set_owned(bool owned) { owned_ = owned; };
  void          set_object( OBJECT *obj, bool own = true ) {
    // no suicides here
    if(owned_ && (obj != object_)) delete object_;
    object_ = const_cast<OBJECT *>(obj);
    owned_ = own;
  }
  // data
private:
  OBJECT *object_;
  mutable bool owned_;
};

/* this is helper function for objecthandles to handle situation when
gtk+'s object might not be available in constructor, see
Gtk_ColorSelectionDialog::get_ok_button() about how to use it */

//template<class T, class K>
//T* Gtkmm_ObjectHandle_create_object(Gtk_ObjectHandle<T> &oh, K* gtkobj)
//{
//  if (!oh.get_object() && gtkobj)
//    {
//      oh.set_object(new T(gtkobj));
//      oh.set_owned(true);
//    }
//  return oh.get_object();
//}

//: This function is used to let the user give up ownership of a widget
//: to a container widget. That is, the container will delete the
//: object when it is itself destroyed.
//: The object must obviously be a pointer.
//: For instance :
//:
//: Gtk_Button *my_button = new Gtk_Button("my button");
//: Gtk_Box box;
//:
//: box.add(manage(my_button));
//:
//template <class T> Gtk_ObjectHandle<T> manage(T *obj);
// Moved to libsigc++

/********************************************************************/

// Replaced with Gtk_SArray factory.
//vector<string> gtkmm_char_ptr_array_to_vector_string(char **strings,
//						     unsigned int nbstrings);
//
// strings is NULL-terminated
//vector<string> gtkmm_char_ptr_array_to_string_vector(char **strings);
//
////: THIS FUNCTION RETURNS AN ALLOCATED OBJECT
//const char** gtkmm_string_vector_to_char_ptr_array(const vector<string> &stringv);
//

//: (internal) Convert C++ list to C list
//- Returns allocated GList of gtk+ objects from a C++ container
//- of gtk-- objects.
template <class iterator>
GList* gtkmm_build_glist(iterator start,iterator stop)
  {
    GList *items=0;
    while (start!=stop)
      {
        if (*start)
          {
           if (!items)
             items=g_list_append(items,(*start)->gtkobj());
           else
             {
               g_list_append(items,(*start)->gtkobj());
               items=items->next;
             }
          }
        ++start;
      }
    if (items) return g_list_first(items);
    return 0;
  }


#endif
