// -*- c++ -*-
//  Generated by gtkmmproc from ./../box.gen_h -- DO NOT MODIFY!
#ifndef _GTKMM_BOX_H
#define _GTKMM_BOX_H

/* $Id: box.gen_h,v 1.60 1999/10/30 06:20:41 kenelson Exp $ */


/* box.h
 *
 * Copyright (C) 1998-1999 The Gtk-- Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gtk--/container.h>
#include <gtk/gtkbox.h>
#include <gtk/gtkvbox.h>
#include <gtk/gtkhbox.h>
class Gtk_Box;
class Gtk_Box_Class;
template <> struct Gtk_Wrap<GtkBox> {typedef Gtk_Box CppType;};
class Gtk_VBox;
class Gtk_VBox_Class;
template <> struct Gtk_Wrap<GtkVBox> {typedef Gtk_VBox CppType;};
class Gtk_HBox;
class Gtk_HBox_Class;
template <> struct Gtk_Wrap<GtkHBox> {typedef Gtk_HBox CppType;};

#ifdef GTKMM_CXX_HAVE_NAMESPACES
namespace Gtk_Box_Helpers
#else
struct Gtk_Box_Helpers
#endif
{
  class Child : protected _GtkBoxChild
    {
      public:
        inline _GtkBoxChild* gtkobj() {return (this);}
        inline const _GtkBoxChild* gtkobj() const {return (this);}

      private:
        Child& operator=(const Child&);
        Child(const Child&);

      protected:
        Child(void* do_not_derive_this);

        inline GtkBox* parent()
          {return GTK_BOX(gtkobj()->widget->parent);}
        void redraw();

      public:
        inline Gtk_Widget* get_widget() const { return gtkmm_wrap(gtkobj()->widget); }

        inline guint16 get_padding() const   { return (gtkobj()->padding); }
        inline bool get_expand() const       { return (gtkobj()->expand); }
        inline bool get_fill() const         { return (gtkobj()->fill); }
        inline bool get_pack() const         { return (gtkobj()->pack); }

        void set_options(bool expand,bool fill,guint padding);
        void set_pack(GtkPackType pack);
    };

  struct Element
    {
      Gtk_Widget* widget_;
      bool expand_;
      bool fill_;
      guint padding_;
      GtkPackType pack_;

      Element(Gtk_Widget& widget,
              bool expand=true,
              bool fill=true,
              guint padding=0,
              GtkPackType pack=GTK_PACK_START)
          : widget_(&widget),expand_(expand),fill_(fill),
            padding_(padding),pack_(pack)
        {}
    };

  typedef Element StartElem;

  struct EndElem : public Element
    {
      EndElem(Gtk_Widget& widget,
              bool expand=true,
              bool fill=true,
              guint padding=0)
          : Element (widget,expand,fill,padding,GTK_PACK_END)
        {}
    };

  class BoxList
    {
      public:
        typedef Child*                       value_type;
        typedef value_type &                       reference;
        typedef const value_type &                 const_reference;

        typedef G_List_Iterator<value_type>        iterator;
        typedef G_List_ConstIterator<iterator>     const_iterator;
        typedef G_List_ReverseIterator<iterator>   reverse_iterator;
        typedef G_List_ConstIterator<reverse_iterator>   const_reverse_iterator;

        typedef size_t                             difference_type;
        typedef size_t                             size_type;

      private:
        friend Gtk_Box;
        Gtk_Box *parent_;
        explicit BoxList(Gtk_Box* parent): parent_(parent) {}

        GList*& glist() const;      // front of list

        iterator begin_() const;
        iterator end_() const;

      public:
        ~BoxList() {}

        inline iterator begin()
          {return begin_();}
        inline iterator end()
          {return end_();}

        inline const_iterator begin() const
          { return const_iterator(begin_()); }
        inline const_iterator end() const
          { return const_iterator(end_()); }

        inline reverse_iterator rbegin()
          { return reverse_iterator(end_()); }
        inline reverse_iterator rend()
          { return reverse_iterator(begin_()); }

        inline const_reverse_iterator rbegin() const
          { return const_reverse_iterator(reverse_iterator(end_())); }
        inline const_reverse_iterator rend() const
          { return const_reverse_iterator(reverse_iterator(begin_())); }

        size_type size(void) const;
        inline size_type max_size(void) { return size_type(-1); }
        inline bool empty(void) { return glist() == 0; }

        iterator insert(iterator position, const Element& e);
        template <class InputIterator>
        inline void insert(iterator position, InputIterator first, InputIterator last)
          { for (;first!=last;++first) position=insert(position,*first); }

        inline void push_front(const Element& e) { insert(begin(), e); }
        inline void push_back(const Element& e)  { insert(end(), e); }
        inline void pop_front()                  { erase(begin()); }
        inline void pop_back()                   { erase(--end()); }

        //reference front()                 { return *begin(); }
        //const_reference front() const     { return *begin(); }
        //reference back()                  { return *(--end()); }
        //const_reference back() const      { return *(--end()); }

        void clear();

        iterator erase(iterator);
        void erase(iterator start, iterator stop);
        void remove(const_reference);

        iterator find(const_reference c);
        iterator find(Gtk_Widget&);

        void remove(Gtk_Widget& w);

        // Non-standard
        void reorder(iterator loc,iterator pos);
     };
};

//: Abstract base class for horizontal and vertical boxes
//- {\class Gtk_Box} is an abstract class and it defers choice of which
//- way the widgets are packed to the screen to the derived classes.
//- {\class Gtk_Box} provides common interface for inserting widgets
//- to a box indepenently of how it is shown in the screen.
//-
//- The most common use of {\class Gtk_Box} is like this:
//- {\example
//-
//- class mywindow : public Gtk_Window {
//-    Gtk_Label label1,label2;
//-    Gtk_VBox vbox;
//- public:
//-    mywindow();
//- };
//- mywindow::mywindow()
//- {
//-    add(vbox);
//-    vbox.pack_end(label1, true, true, 0);
//-    vbox.pack_end(label2, true, true, 0);
//- }
//-
//- }
class Gtk_Box : public Gtk_Container {

public:
  typedef Gtk_Box          CppObjectType;
  typedef Gtk_Box_Class    CppClassType;
  typedef GtkBox           BaseObjectType;
  typedef GtkBoxClass      BaseClassType;

private:
  friend CppClassType;
  static CppClassType box_class;

  Gtk_Box(const Gtk_Box&);
  Gtk_Box& operator=(const Gtk_Box&); // not implemented

protected:
  void   initialize_class();
  void*  get_parent_class() { return static_cast<void*>(parent_class_); }

  static void    init_parent_class()
    { Gtk_Container::get_type(); }
  explicit Gtk_Box(GtkBox *castitem);

public:
  static GtkType get_type();
  GtkBox* gtkobj()             { return GTK_BOX(gtkobject); }
  const GtkBox* gtkobj() const { return GTK_BOX(gtkobject); }
  static bool isA(Gtk_Object *checkcast);

  // Hook for proxies
  static const char* const signal_names[];

  virtual ~Gtk_Box();

private:

public:

  typedef Gtk_Box_Helpers::BoxList BoxList;

  //WRAP_CTOR_CAST;


  //: pack_start inserts a widget to a box.
  //- The expand argument to {pack_start()} or {pack_end()}
  //- controls whether the widgets are laid out in the box to fill in all
  //- the extra space in the box so the box is expanded to fill the area
  //- alloted to it ({\key true}). Or the box is shrunk to just fit the widgets
  //- ({\key false}).  Setting expand to false will allow you to do right and left
  //- justifying of your widgets.  Otherwise, they will all expand to fit in
  //- the box, and the same effect could be achieved by using only one of
  //- {pack_start()} or {pack_end()} functions.
  //-
  //- The fill argument to the {pack_start()}/{pack_end()} functions control whether the
  //- extra space is allocated to the objects themselves ({\key true}), or as extra
  //- padding in the box around these objects (\key{false}). It only has an effect
  //- if the expand argument is also {\key true}.
  //-
  //- What's the difference between spacing (set when the box is created)
  //- and padding (set when elements are packed)? Spacing is added between
  //- objects, and padding is added on either side of an object.
  //-





  void pack_start(Gtk_Widget& child,bool expand=true,bool fill=true,guint padding=0);

  void pack_end(Gtk_Widget& child,bool expand=true,bool fill=true,guint padding=0);

  //- allows setting homongeneous afterwards. This is usually given on
  //- {Gtk_VBox::Gtk_VBox()} or {Gtk_HBox::Gtk_HBox()}


  void set_homogeneous(bool homogeneous);



  void set_spacing(gint spacing);



  void reorder_child(Gtk_Widget& child,gint pos);


// Horrible interface use new one
// void query_child_packing             (Gtk_Widget &child,
//					bool         *expand,
//					bool         *fill,
//					guint        *padding,
//					GtkPackType  *pack_type) const;
// void set_child_packing               (Gtk_Widget &child,
//					bool         expand,
//					bool         fill,
//					guint        padding,
//					GtkPackType  pack_type);
  BoxList& children() {return children_;}
  const BoxList& children() const {return children_;}

protected:
  // WRAP_CTOR_DEFAULT;
  Gtk_Box(void);

protected:

  BoxList children_;

public:
#ifndef GTKMM_CXX_GAUB
  union
    {
#endif
      CppObjectType *box_self;
#ifndef GTKMM_CXX_GAUB
    };
#endif

protected:
  // impl functions

};


//: Vertical Box for laying widgets in a vertical row.
//- You should create these objects, but it is more confortable to
//- pass around pointers of {\class Gtk_Box}. All the methods that do anything
//- are in {\class Gtk_Box} class and this allows you to later change
//- the direction of the box, when there's no dependencies to hbox and
//- vbox classes.
//-
//- See {\class Gtk_Box}.
class Gtk_VBox : public Gtk_Box
{

public:
  typedef Gtk_VBox          CppObjectType;
  typedef Gtk_VBox_Class    CppClassType;
  typedef GtkVBox           BaseObjectType;
  typedef GtkVBoxClass      BaseClassType;

private:
  friend CppClassType;
  static CppClassType vbox_class;

  Gtk_VBox(const Gtk_VBox&);
  Gtk_VBox& operator=(const Gtk_VBox&); // not implemented

protected:
  void   initialize_class();
  void*  get_parent_class() { return static_cast<void*>(parent_class_); }

  static void    init_parent_class()
    { Gtk_Box::get_type(); }
  explicit Gtk_VBox(GtkVBox *castitem);

public:
  static GtkType get_type();
  GtkVBox* gtkobj()             { return GTK_VBOX(gtkobject); }
  const GtkVBox* gtkobj() const { return GTK_VBOX(gtkobject); }
  static bool isA(Gtk_Object *checkcast);

  // Hook for proxies
  static const char* const signal_names[];

  virtual ~Gtk_VBox();

private:

public:

  // See {Gtk_HBox::Gtk_HBox()}.
  Gtk_VBox(bool homogeneous=false, gint spacing=0);

public:
#ifndef GTKMM_CXX_GAUB
  union
    {
#endif
      CppObjectType *vbox_self;
#ifndef GTKMM_CXX_GAUB
    };
#endif

protected:
  // impl functions

};

//: Horizontal Box for laying widgets in a horizontal row.
//- You should create these objects, but it is more confortable to
//- pass around pointers of {\class Gtk_Box}. All the methods that do anything
//- are in {\class Gtk_Box} class and this allows you to later change
//- the direction of the box, when there's no dependencies to hbox and
//- vbox classes.
//-
//- Use the {\class GtkBox} packing interface to determine the arrangement,
//- spacing, width, and alignment of GtkHBox children.
//-
//- All children are allocated the same height.
//-
//- See {\class Gtk_Box}.
class Gtk_HBox : public Gtk_Box
{

public:
  typedef Gtk_HBox          CppObjectType;
  typedef Gtk_HBox_Class    CppClassType;
  typedef GtkHBox           BaseObjectType;
  typedef GtkHBoxClass      BaseClassType;

private:
  friend CppClassType;
  static CppClassType hbox_class;

  Gtk_HBox(const Gtk_HBox&);
  Gtk_HBox& operator=(const Gtk_HBox&); // not implemented

protected:
  void   initialize_class();
  void*  get_parent_class() { return static_cast<void*>(parent_class_); }

  static void    init_parent_class()
    { Gtk_Box::get_type(); }
  explicit Gtk_HBox(GtkHBox *castitem);

public:
  static GtkType get_type();
  GtkHBox* gtkobj()             { return GTK_HBOX(gtkobject); }
  const GtkHBox* gtkobj() const { return GTK_HBOX(gtkobject); }
  static bool isA(Gtk_Object *checkcast);

  // Hook for proxies
  static const char* const signal_names[];

  virtual ~Gtk_HBox();

private:

public:

  //: Creates a new horizontal box
  //- The homogeneous argument to \{class Gtk_HBox}::Gtk_HBox '
  //- (and the same for {\class Gtk_VBox}) controls whether each object
  //- in the box has the same
  //- size (i.e. the same width in an hbox, or the same height in a
  //- vbox). If it is set, the expand argument to the gtk_box_pack routines
  //- is always turned on.
  //-
  //- Spacing determines which
  Gtk_HBox(bool homogeneous=false, gint spacing=0);

  //- See {page docs/castitem}

public:
#ifndef GTKMM_CXX_GAUB
  union
    {
#endif
      CppObjectType *hbox_self;
#ifndef GTKMM_CXX_GAUB
    };
#endif

protected:
  // impl functions

};



//+ PROPERTIES(Gtk_Box)
//. name: children
//. type: GList*
//. get:
//. set:
//. desc:

//. name: spacing
//. type: gint16
//. get:
//. set:
//. desc:

//. name: homogeneous
//. type: guint:1
//. get:
//. set:
//. desc:

#endif
