// -*- c++ -*-
//  Generated by gtkmmproc from ./../clist.gen_h -- DO NOT MODIFY!
#ifndef _GTKMM_CLIST_H
#define _GTKMM_CLIST_H

/* $Id: clist.gen_h,v 1.106 1999/10/18 19:25:53 kenelson Exp $ */

/* clist.h
 *
 * Copyright (C) 1998-1999 The Gtk-- Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gtk--/container.h>
#include <gtk--/scrollbar.h>
#include <gtk/gtkclist.h>
class Gtk_CList;
class Gtk_CList_Class;
template <> struct Gtk_Wrap<GtkCList> {typedef Gtk_CList CppType;};
extern "C" void gtk_clist_set_scroll_adjustments(GtkCList*,GtkAdjustment* p1,GtkAdjustment* p2);


//: Multi-column list widget designed to handle very much data without
//: performance problems
class Gtk_CList : public Gtk_Container
{

public:
  typedef Gtk_CList          CppObjectType;
  typedef Gtk_CList_Class    CppClassType;
  typedef GtkCList           BaseObjectType;
  typedef GtkCListClass      BaseClassType;

private:
  friend CppClassType;
  static CppClassType clist_class;

  Gtk_CList(const Gtk_CList&);
  Gtk_CList& operator=(const Gtk_CList&); // not implemented

protected:
  void   initialize_class();
  void*  get_parent_class() { return static_cast<void*>(parent_class_); }

  static void    init_parent_class()
    { Gtk_Container::get_type(); }
  explicit Gtk_CList(GtkCList *castitem);

public:
  static GtkType get_type();
  GtkCList* gtkobj()             { return GTK_CLIST(gtkobject); }
  const GtkCList* gtkobj() const { return GTK_CLIST(gtkobject); }
  static bool isA(Gtk_Object *checkcast);

  // Hook for proxies
  static const char* const signal_names[];

  virtual ~Gtk_CList();

private:

public:

  Gtk_CList(int columns, const gchar * titles[] = 0);
  Gtk_CList(const Gtk_SArray &titles);



  //: set adjustments of clist


  void set_hadjustment(Gtk_Adjustment* adjustment=0);


  void set_vadjustment(Gtk_Adjustment* adjustment=0);


  void set_hadjustment(Gtk_Adjustment& adjustment);


  void set_vadjustment(Gtk_Adjustment& adjustment);

  //: get adjustments of clist
  Gtk_Adjustment* get_hadjustment() const;

  Gtk_Adjustment* get_vadjustment() const;


  //: set the border style of the clist, valid choices are:
  //- GTK_SHADOW_NONE,
  //- GTK_SHADOW_IN,
  //- GTK_SHADOW_OUT,
  //- GTK_SHADOW_ETCHED_IN,
  //- GTK_SHADOW_ETCHED_OUT


  void set_shadow_type(GtkShadowType type);

  //: set the clist's selection mode
  //- GTK_SELECTION_SINGLE,
  //- GTK_SELECTION_BROWSE,
  //- GTK_SELECTION_MULTIPLE,
  //- GTK_SELECTION_EXTENDED


  void set_selection_mode(GtkSelectionMode mode);



  //: enable clists reorder ability


  void set_reorderable(bool reorderable);


  void set_use_drag_icons(bool use_icons);


  void set_button_actions(guint button,guint8 button_actions);



  //: freeze all visual updates of the list
  //- and then thaw the list after you
  //- have made a number of changes and the updates will occure in a more
  //- efficent manner than if you made them on a unfrozen list


  void freeze();
  //: thaw the list (see <A HREF="#freeze">freeze</A>)


  void thaw();



  //: show the column title buttons


  void column_titles_show();
  //: hide the column title buttons


  void column_titles_hide();



  //: activate title
  //- (responds to button presses, prelights, and grabs keyboard focus)


  void column_title_active(gint column);
  //: set the column title to be passive where it acts as just a title


  void column_title_passive(gint column);
  //: set all column titles to be a active
  //- (respond to button presses, prelight, and grab keyboard focus)


  void column_titles_active();
  //: set all column titles to be passive where they act as just a title


  void column_titles_passive();



  //: set the title in the column title button


  void set_column_title(gint column,const string& title);
  //: returns the title of column. Returns an empty string if title is not set


  string get_column_title(gint column) const;



  //: set a widget instead of a title for the column title button


  void set_column_widget(gint column,Gtk_Widget& widget);
  //: set a widget instead of a title for the column title button
    //void set_column_widget(gint column, const Gtk_ObjectHandle<Gtk_Widget> &widget);
  //: returns the column widget


  Gtk_Widget* get_column_widget(gint column) const;



  //: set the justification on a column
  //- valid choices are:
  //- GTK_JUSTIFY_LEFT,
  //- GTK_JUSTIFY_RIGHT,
  //- GTK_JUSTIFY_CENTER,
  //- GTK_JUSTIFY_FILL


  void set_column_justification(gint column,GtkJustification justification);

  //: set visibility of a column


  void set_column_visibility(gint column,bool visible);

  //: enable/disable column resize operations by mouse


  void set_column_resizeable(gint column,bool resizeable);

  //: resize column automatically to its optimal width


  void set_column_auto_resize(gint column,bool auto_resize);


  gint columns_autosize();



  //: return the optimal column width, i.e. maximum of all cell widths


  gint optimal_column_width(gint column) const;

  //: set the pixel width of a column; this is a necessary step in
  //- creating a CList because otherwise the column width is chozen from
  //- the width of the column title, which will never be right


  void set_column_width(gint column,gint width);


  //: set column minimum/maximum width. min/max_width < 0 => no restriction


  void set_column_min_width(gint column,gint min_width);


  void set_column_max_width(gint column,gint max_width);


  //: change the height of one row
  //- the default is the hight of the current font


  void set_row_height(guint height);



  //: scroll the viewing area of the list
  //- to the given column
  //- and row; row_align and col_align are between 0-1 representing the
  //- location the row should appear on the screnn, 0.0 being top or left,
  //- 1.0 being bottom or right; if row or column is -1 then then there
  //- is no change


  void moveto(gint row,gint column,gfloat row_align=0.5,gfloat col_align=0.5);


  //: whether the row is visible


  GtkVisibility row_is_visible(gint row) const;

  //: returns the cell type which is one of
  //- GTK_CELL_EMPTY,
  //- GTK_CELL_TEXT,
  //- GTK_CELL_PIXMAP,
  //- GTK_CELL_PIXTEXT,
  //- GTK_CELL_WIDGET


  GtkCellType get_cell_type(gint row,gint column) const;


  //: sets a given cell's text, replacing it's current contents


  void set_text(gint row,gint column,const string& text);

  //: get cell's text
  //- returns true on success
  bool         get_text(gint row, gint column, gtkmm_string *text) const;
  bool         get_text(gint row, gint column, string &text) const;
  gtkmm_string get_text(gint row, gint column) const;


  //: sets a given cell's pixmap, replacing it's current contents



  void set_pixmap(gint row,gint column,const Gdk_Pixmap& pixmap,const Gdk_Bitmap& mask);
  //: get cell's pixmap
  //- returns 1 on success
  //- any of the return pointer can be NULL if you are not interested
  gint get_pixmap(gint row, gint column,
                  Gdk_Pixmap &pixmap, Gdk_Bitmap &mask) const;


  //: sets a given cell's pixmap and text, replacing it's current contents




  void set_pixtext(gint row,gint column,const string& text,guint8 spacing,const Gdk_Pixmap& pixmap,const Gdk_Bitmap& mask);
  //: any of the return pointer can be NULL if you are not interested
  bool get_pixtext(gint row, gint column, gtkmm_string *text,
                   guint8 *spacing,
                   Gdk_Pixmap &pixmap, Gdk_Bitmap &mask) const;



  //: sets the foreground color of a row, the color must already
  //- be allocated


  void set_foreground(gint row,const Gdk_Color& color);
  //: sets the background color of a row, the color must already
  //- be allocated


  void set_background(gint row,const Gdk_Color& color);

  //: set / get cell styles


  void set_cell_style(gint row,gint column,Gtk_Style& style);


  void set_row_style(gint row,Gtk_Style& style);

  Gtk_Style* get_row_style  (gint      row) const;
  Gtk_Style* get_cell_style (gint      row, gint      column) const;


  //: set/get selectable flag of a single row


  void set_selectable(gint row,bool selectable);


  bool get_selectable(gint row) const;



  //: this sets a horizontal and vertical  for drawing
  //- the contents of a cell; it can be positive or negative; this is
  //- particulary useful for indenting items in a column


  void set_shift(gint row,gint column,gint vertical,gint horizontal);



  //: prepend/append returns the index of the row you just added, making
  //- it easier to append and modify a row<p>
  //- Example:
  //- <pre>
  //- gchar **row = new gchar*[num_of_columns];
  //- row[0]="cell1";
  //- row[1]="cell2";
  //- ...
  //- row[num_of_columns-1]="cellN-1";
  //- clist->append(row);
  //- </pre>


  gint prepend(const Gtk_SArray& text);


  gint append(const Gtk_SArray& text);

  //: *_row functions added for symmetry reasons


  gint prepend_row(const Gtk_SArray& text);


  gint append_row(const Gtk_SArray& text);

  //: inserts a row at index row
  //- Note: this is gtk_clist_insert() in gtk, but renamed here to
  //-       insert_row()


  gint insert_row(gint row,const Gtk_SArray& text);

  //: removes row at index row
  //- Note: this is gtk_clist_remove() in gtk, but renamed
  //-       here to remove_row()


  void remove_row(gint row);



  //: iterator for traversing over the rows
  typedef G_List_Iterator<GtkCListRow*> iterator;
  //: iterator for traversing through selected items
  typedef G_IntList_Iterator seliterator;

  //: beginning of row_list
  iterator begin();
  //: end of row_list
  iterator end();

  //: beginning of selection (STL style iterators)
  seliterator selbegin();
  //: end of selection (STL style iterators)
  seliterator selend();

private:
  virtual bool check_seliterator_type() const;


public:

  //: sets a arbitrary data pointer for a given row


  void set_row_data(gint row,gpointer data);
  //: returns the data set for a row


  gpointer get_row_data(gint row) const;


  //: sets a data pointer for a given row with destroy notification


  void set_row_data_full(gint row,gpointer data,GtkDestroyNotify destroy);

  //: given a data pointer, find the first (and hopefully only!)
  //- row that points to that data, or -1 if none do


  gint find_row_from_data(gpointer data) const;


  //: force selection of a row


  void cause_select_row(gint row,gint column);
  //: force unselection of a row


  void cause_unselect_row(gint row,gint column);

  //: undo the last select/unselect operation
  //- is a signal!!
  //void undo_selection());

  //: clear the entire list -- this is much faster than removing
  //- each item with remove.


  void clear();


  //: return the row column corresponding to the x and y coordinates
  //- <P> reference and pointer style available



  gint get_selection_info(gint x,gint y,gint* row,gint* column) const;


  //: in multiple or extended mode, select all rows
  //- is a signal!!
  //void select_all ();

  //: in all modes except browse mode, deselect all rows
  //- is a signal!!
  //void unselect_all ();


  //: swap the position of two rows


  void swap_rows(gint row1,gint row2);

  //: move row from source_row position to dest_row position
  //- is a signal!!
  //void gtk_clist_row_move(gint source_row, gint dest_row);


  //: sets a compare function different to the default


  void set_compare_func(GtkCListCompareFunc cmp_func);

  //: the column to sort by


  void set_sort_column(gint column);

  //: how to sort : ascending or descending


  void set_sort_type(GtkSortType sort_type);

  //: sort the list with the current compare function


  void sort();

  //: Automatically sort upon insertion


  void set_auto_sort(bool auto_sort);


  //: returns the width in pixels of the column, returns -1 if the column
  //- doens't exist column is 0 based.
  gint get_column_width(gint column) const;


  //: A couple of convenience accessors
  gint rows()    { return gtkobj()->rows; }
  gint columns() { return gtkobj()->columns; }



  //
  // signals
  //

  //: for user emittable functions see cause_select_row(), cause_unselect_row()

  // how does this interact with a scrollwindow/scrollbars?





  // This is user overridable functions.  They are not signals

  // user overrideable functions
 //const Gtk_SArray&));

public:
    class Proxy_set_scroll_adjustments
      : public EmitProxySignal2<void,GtkAdjustment*,GtkAdjustment*,CppObjectType,BaseObjectType,16,&gtk_clist_set_scroll_adjustments>
      {
          typedef EmitProxySignal2<void,GtkAdjustment*,GtkAdjustment*,CppObjectType,BaseObjectType,16,&gtk_clist_set_scroll_adjustments> BaseType;
          static void convert_func(Callback2<void,Gtk_Adjustment*,Gtk_Adjustment*> *s,GtkAdjustment*,GtkAdjustment*);
        public:
          void operator ()(Gtk_Adjustment*,Gtk_Adjustment*);
          void emit(Gtk_Adjustment*,Gtk_Adjustment*);
          Connection connect(const Slot2<void,Gtk_Adjustment*,Gtk_Adjustment*> &s)
            {return BaseType::connect(convert(s,&convert_func));}

      };
#ifndef GTKMM_CXX_GAUB
  union
    {
#endif
      CppObjectType *clist_self;
      ProxySignal3<void,gint,gint,GdkEvent*,CppObjectType,BaseObjectType,0> select_row;
      ProxySignal3<void,gint,gint,GdkEvent*,CppObjectType,BaseObjectType,1> unselect_row;
      EmitProxySignal2<void,gint,gint,CppObjectType,BaseObjectType,2,&gtk_clist_row_move> row_move;
      ProxySignal1<void,gint,CppObjectType,BaseObjectType,3> click_column;
      ProxySignal2<void,gint,gint,CppObjectType,BaseObjectType,4> resize_column;
      ProxySignal0<void,CppObjectType,BaseObjectType,5> toggle_focus_row;
      ProxySignal0<void,CppObjectType,BaseObjectType,6> toggle_add_mode;
      EmitProxySignal0<void,CppObjectType,BaseObjectType,7,&gtk_clist_select_all> select_all;
      EmitProxySignal0<void,CppObjectType,BaseObjectType,8,&gtk_clist_unselect_all> unselect_all;
      EmitProxySignal0<void,CppObjectType,BaseObjectType,9,&gtk_clist_undo_selection> undo_selection;
      ProxySignal0<void,CppObjectType,BaseObjectType,10> start_selection;
      ProxySignal0<void,CppObjectType,BaseObjectType,11> end_selection;
      ProxySignal3<void,GtkScrollType,gfloat,gboolean,CppObjectType,BaseObjectType,12> extend_selection;
      ProxySignal2<void,GtkScrollType,gfloat,CppObjectType,BaseObjectType,13> scroll_vertical;
      ProxySignal2<void,GtkScrollType,gfloat,CppObjectType,BaseObjectType,14> scroll_horizontal;
      ProxySignal0<void,CppObjectType,BaseObjectType,15> abort_column_resize;
      Proxy_set_scroll_adjustments set_scroll_adjustments;
#ifndef GTKMM_CXX_GAUB
    };
#endif

protected:
  // impl functions
    virtual void select_row_impl(gint p0,gint p1,GdkEvent* p2);
    virtual void unselect_row_impl(gint p0,gint p1,GdkEvent* p2);
    virtual void row_move_impl(gint p0,gint p1);
    virtual void click_column_impl(gint p0);
    virtual void resize_column_impl(gint p0,gint p1);
    virtual void toggle_focus_row_impl();
    virtual void toggle_add_mode_impl();
    virtual void select_all_impl();
    virtual void unselect_all_impl();
    virtual void undo_selection_impl();
    virtual void start_selection_impl();
    virtual void end_selection_impl();
    virtual void extend_selection_impl(GtkScrollType p0,gfloat p1,gboolean p2);
    virtual void scroll_vertical_impl(GtkScrollType p0,gfloat p1);
    virtual void scroll_horizontal_impl(GtkScrollType p0,gfloat p1);
    virtual void abort_column_resize_impl();
    virtual void set_scroll_adjustments_impl(Gtk_Adjustment* p0,Gtk_Adjustment* p1);
    virtual int insert_row_impl(gint row,gchar** p1);
    virtual void remove_row_impl(gint row);
    virtual void clear_impl();
    virtual void sort_list_impl();

};

typedef Gtk_CList Gtk_ColumnList;



//+ PROPERTIES(Gtk_CList)
//. name: flags
//. type: guint16
//. get:
//. set:
//. desc:

//. name: row_mem_chunk
//. type: GMemChunk*
//. get:
//. set:
//. desc: mem chunks

//. name: cell_mem_chunk
//. type: GMemChunk*
//. get:
//. set:
//. desc:

//. name: freeze_count
//. type: guint
//. get:
//. set:
//. desc:

//. name: internal_allocation
//. type: GdkRectangle
//. get:
//. set:
//. desc: allocation rectangle after the conatiner_border_width
//.    * and the width of the shadow border

//. name: rows
//. type: gint
//. get:
//. set:
//. desc: rows

//. name: row_center_offset
//. type: gint
//. get:
//. set:
//. desc:

//. name: row_height
//. type: gint
//. get:
//. set:
//. desc:

//. name: row_list
//. type: GList*
//. get:
//. set:
//. desc:

//. name: row_list_end
//. type: GList*
//. get:
//. set:
//. desc:

//. name: columns
//. type: gint
//. get:
//. set:
//. desc: columns

//. name: column_title_area
//. type: GdkRectangle
//. get:
//. set:
//. desc:

//. name: title_window
//. type: GdkWindow*
//. get:
//. set:
//. desc:

//. name: column
//. type: GtkCListColumn*
//. get:
//. set:
//. desc: dynamicly allocated array of column structures

//. name: clist_window
//. type: GdkWindow*
//. get:
//. set:
//. desc:the scrolling window and it's height and width to
//.    * make things a little speedier

//. name: clist_window_width
//. type: gint
//. get:
//. set:
//. desc:

//. name: clist_window_height
//. type: gint
//. get:
//. set:
//. desc:

//. name: hoffset
//. type: gint
//. get:
//. set:
//. desc: offsets for scrolling

//. name: voffset
//. type: gint
//. get:
//. set:
//. desc:

//. name: shadow_type
//. type: GtkShadowType
//. get:
//. set:
//. desc: border shadow style

//. name: selection_mode
//. type: GtkSelectionMode
//. get:
//. set:
//. desc: the list's selection mode (gtkenums.h)

//. name: selection
//. type: GList*
//. get:
//. set:
//. desc: list of selected rows

//. name: selection_end
//. type: GList*
//. get:
//. set:
//. desc:

//. name: undo_selection
//. type: GList*
//. get:
//. set:
//. desc:

//. name: undo_unselection
//. type: GList*
//. get:
//. set:
//. desc:

//. name: undo_anchor
//. type: gint
//. get:
//. set:
//. desc:

//. name: button_actions
//. type:
//. get:
//. set:
//. desc: mouse buttons

//. name: drag_button
//. type: guint8
//. get:
//. set:
//. desc:

//. name: click_cell
//. type: GtkCListCellInfo
//. get:
//. set:
//. desc: dnd

//. name: hadjustment
//. type: GtkAdjustment*
//. get:
//. set:
//. desc: scroll adjustments

//. name: vadjustment
//. type: GtkAdjustment*
//. get:
//. set:
//. desc:

//. name: xor_gc
//. type: GdkGC*
//. get:
//. set:
//. desc: xor GC for the vertical drag line

//. name: fg_gc
//. type: GdkGC*
//. get:
//. set:
//. desc: gc for drawing unselected cells

//. name: bg_gc
//. type: GdkGC*
//. get:
//. set:
//. desc:

//. name: cursor_drag
//. type: GdkCursor*
//. get:
//. set:
//. desc: cursor used to indicate dragging

//. name: x_drag
//. type: gint
//. get:
//. set:
//. desc: the current x-pixel location of the xor-drag line

//. name: focus_row
//. type: gint
//. get:
//. set:
//. desc: focus handling

//. name: anchor
//. type: gint
//. get:
//. set:
//. desc: dragging the selection

//. name: anchor_state
//. type: GtkStateType
//. get:
//. set:
//. desc:

//. name: drag_pos
//. type: gint
//. get:
//. set:
//. desc:

//. name: htimer
//. type: gint
//. get:
//. set:
//. desc:

//. name: vtimer
//. type: gint
//. get:
//. set:
//. desc:

//. name: sort_type
//. type: GtkSortType
//. get:
//. set:
//. desc:

//. name: compare
//. type: GtkCListCompareFunc
//. get:
//. set:
//. desc:

//. name: sort_column
//. type: gint
//. get:
//. set:
//. desc:

#endif
