// -*- c++ -*-
//  Generated by gtkmmproc from ./../list.gen_h -- DO NOT MODIFY!
#ifndef _GTKMM_LIST_H
#define _GTKMM_LIST_H

/* $Id: list.gen_h,v 1.46 1999/11/05 18:50:34 kenelson Exp $ */

/* list.h
 *
 * Copyright (C) 1998-1999 The Gtk-- Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gtk--/container.h>
#include <gtk--/listitem.h>
#include <gtk/gtklist.h>
class Gtk_List;
class Gtk_List_Class;
template <> struct Gtk_Wrap<GtkList> {typedef Gtk_List CppType;};

#ifdef GTKMM_CXX_HAVE_NAMESPACES
namespace Gtk_List_Helpers
#else
struct Gtk_List_Helpers
#endif
{

  class ItemList
    {
      public:
        typedef Gtk_ListItem*                       value_type;
        typedef value_type &                       reference;
        typedef const value_type &                 const_reference;

        typedef G_List_Cpp_Iterator<GtkListItem,Gtk_ListItem>        iterator;
        typedef G_List_ConstIterator<iterator>     const_iterator;
        typedef G_List_ReverseIterator<iterator>   reverse_iterator;
        typedef G_List_ConstIterator<reverse_iterator>   const_reverse_iterator;

        typedef size_t                             difference_type;
        typedef size_t                             size_type;

      private:
        friend Gtk_List;
        Gtk_List *parent_;
        explicit ItemList(Gtk_List* parent): parent_(parent) {}

        GList*& glist() const;      // front of list

        iterator begin_() const;
        iterator end_() const;

      public:
        ~ItemList() {}

        inline iterator begin()
          {return begin_();}
        inline iterator end()
          {return end_();}

        inline const_iterator begin() const
          { return const_iterator(begin_()); }
        inline const_iterator end() const
          { return const_iterator(end_()); }

        inline reverse_iterator rbegin()
          { return reverse_iterator(end_()); }
        inline reverse_iterator rend()
          { return reverse_iterator(begin_()); }

        inline const_reverse_iterator rbegin() const
          { return const_reverse_iterator(reverse_iterator(end_())); }
        inline const_reverse_iterator rend() const
          { return const_reverse_iterator(reverse_iterator(begin_())); }

        size_type size(void) const;
        inline size_type max_size(void) { return size_type(-1); }
        inline bool empty(void) { return glist() == 0; }

        iterator insert(iterator position, Gtk_ListItem& e);
        template <class InputIterator>
        inline void insert(iterator position, InputIterator first, InputIterator last)
          { for (;first!=last;++first) position=insert(position,*first); }

        inline void push_front(Gtk_ListItem& e) { insert(begin(), e); }
        inline void push_back(Gtk_ListItem& e)  { insert(end(), e); }
        inline void pop_front()                  { erase(begin()); }
        inline void pop_back()                   { erase(--end()); }

        //reference front()                 { return *begin(); }
        //const_reference front() const     { return *begin(); }
        //reference back()                  { return *(--end()); }
        //const_reference back() const      { return *(--end()); }

        void clear();

        iterator erase(iterator);
        void erase(iterator start, iterator stop);
        void remove(const_reference);

        void remove(Gtk_Widget& w);

     };

  class SelectionList
    {
      public:
        typedef Gtk_ListItem*                       value_type;
        typedef value_type &                       reference;
        typedef const value_type &                 const_reference;

        typedef G_List_Cpp_Iterator<GtkListItem,Gtk_ListItem>        iterator;
        typedef G_List_ConstIterator<iterator>     const_iterator;
        typedef G_List_ReverseIterator<iterator>   reverse_iterator;
        typedef G_List_ConstIterator<reverse_iterator>   const_reverse_iterator;

        typedef size_t                             difference_type;
        typedef size_t                             size_type;

      private:
        friend Gtk_List;
        Gtk_List *parent_;
        explicit SelectionList(Gtk_List* parent): parent_(parent) {}

        GList*& glist() const;      // front of list

        iterator begin_() const;
        iterator end_() const;

      public:
        ~SelectionList() {}

        inline iterator begin()
          {return begin_();}
        inline iterator end()
          {return end_();}

        inline const_iterator begin() const
          { return const_iterator(begin_()); }
        inline const_iterator end() const
          { return const_iterator(end_()); }

        inline reverse_iterator rbegin()
          { return reverse_iterator(end_()); }
        inline reverse_iterator rend()
          { return reverse_iterator(begin_()); }

        inline const_reverse_iterator rbegin() const
          { return const_reverse_iterator(reverse_iterator(end_())); }
        inline const_reverse_iterator rend() const
          { return const_reverse_iterator(reverse_iterator(begin_())); }

        size_type size(void) const;
        inline size_type max_size(void) { return size_type(-1); }
        inline bool empty(void) { return glist() == 0; }

     };

};

//: Slow implementation of lists.
// Gtk_List is somewhat broken. To insert anything useful to list at its
// current state, use Gtk_Container::add(Gtk_Widget*)
class Gtk_List : public Gtk_Container {

public:
  typedef Gtk_List          CppObjectType;
  typedef Gtk_List_Class    CppClassType;
  typedef GtkList           BaseObjectType;
  typedef GtkListClass      BaseClassType;

private:
  friend CppClassType;
  static CppClassType list_class;

  Gtk_List(const Gtk_List&);
  Gtk_List& operator=(const Gtk_List&); // not implemented

protected:
  void   initialize_class();
  void*  get_parent_class() { return static_cast<void*>(parent_class_); }

  static void    init_parent_class()
    { Gtk_Container::get_type(); }
  explicit Gtk_List(GtkList *castitem);

public:
  static GtkType get_type();
  GtkList* gtkobj()             { return GTK_LIST(gtkobject); }
  const GtkList* gtkobj() const { return GTK_LIST(gtkobject); }
  static bool isA(Gtk_Object *checkcast);

  // Hook for proxies
  static const char* const signal_names[];

  virtual ~Gtk_List();

private:

public:
  typedef Gtk_List_Helpers::ItemList ItemList;
  typedef Gtk_List_Helpers::SelectionList SelectionList;

  Gtk_List();

  template <class iterator>
  void append_items(iterator start,iterator stop);
  template <class iterator>
  void prepend_items(iterator start,iterator stop);
  template <class iterator>
  void insert_items(iterator start,iterator stop,int pos);
  template <class iterator>
  void remove_items(iterator start,iterator stop);



  void insert_items(GList* items,gint position);



  void append_items(GList* items);



  void prepend_items(GList* items);



  void remove_items(GList* items);



  void remove_items_no_unref(GList* items);



  void clear_items(gint start,gint end);



  void select_item(gint item);



  void unselect_item(gint item);

  // need to fix gtk+ on the const


  gint child_position(Gtk_Widget& child);



  void set_selection_mode(GtkSelectionMode mode);


  ItemList& items()                       {return items_;}
  const ItemList& items() const           {return items_;}

  SelectionList& selection()              {return selection_;}
  const SelectionList& selection() const  {return selection_;}

private:
  ItemList items_;
  SelectionList selection_;

public:
    class Proxy_select_child
      : public EmitProxySignal1<void,GtkWidget*,CppObjectType,BaseObjectType,1,&gtk_list_select_child>
      {
          typedef EmitProxySignal1<void,GtkWidget*,CppObjectType,BaseObjectType,1,&gtk_list_select_child> BaseType;
          static void convert_func(Callback1<void,Gtk_Widget&> *s,GtkWidget*);
        public:
          void operator ()(Gtk_Widget&);
          void emit(Gtk_Widget&);
          Connection connect(const Slot1<void,Gtk_Widget&> &s)
            {return BaseType::connect(convert(s,&convert_func));}

      };
    class Proxy_unselect_child
      : public EmitProxySignal1<void,GtkWidget*,CppObjectType,BaseObjectType,2,&gtk_list_unselect_child>
      {
          typedef EmitProxySignal1<void,GtkWidget*,CppObjectType,BaseObjectType,2,&gtk_list_unselect_child> BaseType;
          static void convert_func(Callback1<void,Gtk_Widget&> *s,GtkWidget*);
        public:
          void operator ()(Gtk_Widget&);
          void emit(Gtk_Widget&);
          Connection connect(const Slot1<void,Gtk_Widget&> &s)
            {return BaseType::connect(convert(s,&convert_func));}

      };
#ifndef GTKMM_CXX_GAUB
  union
    {
#endif
      CppObjectType *list_self;
      ProxySignal0<void,CppObjectType,BaseObjectType,0> selection_changed;
      Proxy_select_child select_child;
      Proxy_unselect_child unselect_child;
#ifndef GTKMM_CXX_GAUB
    };
#endif

protected:
  // impl functions
    virtual void selection_changed_impl();
    virtual void select_child_impl(Gtk_Widget& p0);
    virtual void unselect_child_impl(Gtk_Widget& p0);

};

template <class iterator>
void Gtk_List::insert_items(iterator start, iterator stop, gint pos)
  {
    GList* items=gtkmm_build_glist(start,stop);
    if (items) gtk_list_insert_items(gtkobj(),items,pos);
  }

template <class iterator>
void Gtk_List::prepend_items(iterator start, iterator stop)
  {
    GList* items=gtkmm_build_glist(start,stop);
    if (items) gtk_list_prepend_items(gtkobj(),items);
  }

template <class iterator>
void Gtk_List::append_items(iterator start, iterator stop)
  {
    GList* items=gtkmm_build_glist(start,stop);
    if (items) gtk_list_append_items(gtkobj(),items);
  }

template <class iterator>
void Gtk_List::remove_items(iterator start, iterator stop)
  {
    GList* items=gtkmm_build_glist(start,stop);
    if (items) gtk_list_remove_items(gtkobj(),items);
    g_list_free(items);
  }



//+ PROPERTIES(Gtk_List)
//. name: children
//. type: GList*
//. get:
//. set:
//. desc:

//. name: selection
//. type: GList*
//. get:
//. set:
//. desc:

//. name: undo_selection
//. type: GList*
//. get:
//. set:
//. desc:

//. name: undo_unselection
//. type: GList*
//. get:
//. set:
//. desc:

//. name: last_focus_child
//. type: Gtk_Widget*
//. get:
//. set:
//. desc:

//. name: undo_focus_child
//. type: Gtk_Widget*
//. get:
//. set:
//. desc:

//. name: htimer
//. type: guint
//. get:
//. set:
//. desc:

//. name: vtimer
//. type: guint
//. get:
//. set:
//. desc:

//. name: anchor
//. type: gint
//. get:
//. set:
//. desc:

//. name: drag_pos
//. type: gint
//. get:
//. set:
//. desc:

//. name: anchor_state
//. type: GtkStateType
//. get:
//. set:
//. desc:

//. name: selection_mode
//. type: guint:2
//. get:
//. set:
//. desc:

//. name: drag_selection
//. type: guint:1
//. get:
//. set:
//. desc:

//. name: add_mode
//. type: guint:1
//. get:
//. set:
//. desc:

#endif
