// -*- c++ -*-
//  Generated by gtkmmproc from ./../main.gen_h -- DO NOT MODIFY!
#ifndef _GTKMM_MAIN_H
#define _GTKMM_MAIN_H

/* $Id: main.gen_h,v 1.45 1999/10/18 03:17:15 kenelson Exp $ */

/* main.h
 *
 * Copyright (C) 1998-1999 The Gtk-- Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gtk/gtkmain.h>
#include <gtk--/base.h>
class Gtk_Widget;

//**********************************************************************

//: Idle Signal Class (internal)
class Gtk_IdleSig
{
public:
  typedef Callback0<gint> Callback;
  typedef Slot0<gint> SlotType;

protected:
  static gint gtk_callback(gpointer d);

public:
  Connection connect(const SlotType &sd,gint priority = GTK_PRIORITY_DEFAULT);
};

//: Timeout Signal Class (internal)
class Gtk_TimeoutSig
{
public:
  typedef Callback0<gint> Callback;
  typedef Slot0<gint> SlotType;

protected:
  static gint gtk_callback(gpointer d);

public:
  Connection connect(const SlotType &sd,guint32 interval);
};

//: KeySnooper Signal Class (internal)
class Gtk_KeySnooperSig
{
public:
  typedef Callback2<gint,Gtk_Widget*,GdkEventKey*>         Callback;
  typedef Slot2<gint,Gtk_Widget*,GdkEventKey*>             SlotType;

protected:
  static gint gtk_callback(GtkWidget* w,GdkEventKey* k,gpointer d);

public:
  Connection connect(const SlotType &sd);
};

//: Input Signal Class (internal)
class Gtk_InputSig
{
public:
// typedef void (*GdkInputFunction) (gpointer          data,
//                                  gint              source,
//                                  GdkInputCondition condition);
// Source: File descriptor
// Condition: GDK_INPUT_READ, GDK_INPUT_WRITE, GDK_INPUT_EXCEPTION

  typedef Callback2<void,gint,GdkInputCondition>         Callback;
  typedef Slot2<void,gint,GdkInputCondition>             SlotType;

protected:
  static void gtk_callback(gpointer          data,
                           gint              source,
                           GdkInputCondition condition);

public:
  Connection connect(const SlotType &sd,
                     gint source,
                     GdkInputCondition condition);
};

//: Quit Signal Class (internal)
class Gtk_QuitSig
{
public:
  typedef Callback0<gint> Callback;
  typedef void SType;
  typedef gint RType;
  typedef Slot0<SType> OutSlotType;
  typedef Slot0<RType> InSlotType;
  typedef CallDataObj2<OutSlotType::Func,int> Data;

protected:
  static gint gtk_callback(gpointer          data);
  static void callback(void* data);

public:
  Connection connect(const InSlotType &sd,guint main_level=0);
  OutSlotType slot();
  void emit()       { callback(0); }
  void operator()() { callback(0); }
};



//**********************************************************************

//: Main application class
//- Every application must have one of these objects.
//- (actually can have more than one, but all Gtk_Main
//- objects handle the same instance - at least for now)
//-
//- Normal use of this class is in main() function to give argc and argv
//- to the gtk initialization. Widgets can use Gtk_Main::quit()
//- for example to exit from the application.
//-
//- The internals of the widget have been disguised as signals
//- so that the user can easily connect using the same methods
//- used throughout the widget interface.
//-
//- Minimal gtk-- application is something like this:<br>
//- {\example
//-   void main(int argc, char *argv[]) {
//-     Gtk_Main m(argc, argv);
//-     ... create some widgets ...
//-     m.run();
//-   }
//- }

class Gtk_Main : public SigC::Object {
  friend Gtk_QuitSig;
protected:
  static Gtk_Main *instance_;
public:
  // access to one global instance of Gtk_Main.
  static Gtk_Main *instance() { return instance_; }

  Gtk_Main(int *argc, char ***argv, bool have_locale=false);
  Gtk_Main(int &argc, char **&argv, bool have_locale=false);
  ~Gtk_Main();

  static void run()             {instance_->run_impl();}
  static void iteration(bool blocking=TRUE)
                                {instance_->iteration_impl(blocking);}
  static gint events_pending()  {return instance_->events_pending_impl();}

  //: Grabs events to a widget modal
  //- Prevents events to everything else than given widget and its
  //- childs. This way you can create modal dialogs(not recommended).
  static void grab_add(Gtk_Widget &widget);

  //: Removes event grab
  static void grab_remove(Gtk_Widget &widget);

  //: Returns the widget which is grabbing events
  static Gtk_Widget* grab_get_current();

  static void gtk_true();
  static void gtk_false();

  //: Idle signal
  //- idle provides a way to setup a callback that will be
  //- called when gtk has nothing else to do, when the execution has
  //- returned from all callbacks etc.
  //-
  //- Return value of the callback will determine if the callback is
  //- removed. 0 means callback is removed, 1 means it'll be called again
  //- after gtk next time has nothing to do.
  //-
  //- Example:
  //- {\example
  //-   gint thisclass::mymethod() { return 1; }
  //-   Gtk_Main::idle.connect(slot(this,&thisclass::mymethod));
  //- }
  //-
  //- You can supply an integer priority to the idle() call; by default, it's
  //-  GTK_PRIORITY_DEFAULT, lower numbers are higher priority.
  static Gtk_IdleSig idle;

  //: Timeout signal
  //- timeout provides a way to setup a callback that will be called when
  //- certain time has elapsed.
  //-
  //- Return value of the callback will determine if the callback is
  //- removed. 0 means callback is removed, 1 means it'll call it again after
  //- the time has again elapsed.
  //-
  //- Example:
  //- {\example
  //-   gint thisclass::mymethod() { return 1; }
  //-   Gtk_Main::timeout.connect(slot(this,&thisclass::mymethod),100);
  //- }
  static Gtk_TimeoutSig timeout;

  //: KeySnooper signal
  //- key_snooper provides a way to channel keypresses to a callback
  //- without registering with the widget.
  //-
  //- Callbacks will get the name of the widget and the keypress event.
  //- It is the responsiblity of the snooper to pass the keypress
  //- to the widget, however, care must be given that the keypress is
  //- not passed twice.
  static Gtk_KeySnooperSig key_snooper;

  //: Input signal
  //- input provies a way to monitor a file descriptor for activity
  //- for a number of conditions.
  //- Conditions can be any combination of
  //- GDK_INPUT_READ, GDK_INPUT_WRITE, GDK_INPUT_EXCEPTION
  //- For more information please read the select(2) man page.
  //-
  //- (This is largely a front for a gdk_input_add_full)
  //-
  //- Example:
  //- {\example
  //-   gint thisclass::mymethod() { return 1; }
  //-   int file=open("bob",O_RDONLY);
  //-   Gtk_Main::input.connect(slot(this,&thisclass::mymethod),
  //-                           file,
  //-                           GDK_INPUT_READ|GDK_INPUT_EXCEPTION);
  //- }
  static Gtk_InputSig input;

  //: Quit signal
  //- quit is an emitable signal which terminates the application.
  //- You can connect callbacks to it to invoke actions when the
  //- user has requested the application should terminate.
  //-
  //- Example:
  //- {\example
  //- Connecting to:
  //-   gint thisclass::mymethod() { return 1; }
  //-   Gtk_Main::quit.connect(slot(this,&thisclass::mymethod);
  //-
  //- Invoking when:
  //-   Gtk_Button button;
  //-
  //-   button.clicked.connect(Gtk_Main::quit.slot());
  //-
  //- Calling directly:
  //-   Gtk_Main::quit();
  //- }
  static Gtk_QuitSig quit;

protected:
  Gtk_Main();

  void init(int *argc, char ***argv,
	    bool have_locale);

  void init_gtkmm_internals();

  virtual void run_impl();
  virtual void quit_impl();
  virtual void iteration_impl(bool blocking);
  virtual gint events_pending_impl();
};


#endif
