// -*- c++ -*-
//  Generated by gtkmmproc from ./../menu.gen_h -- DO NOT MODIFY!
#ifndef _GTKMM_MENU_H
#define _GTKMM_MENU_H

/* $Id: menu.gen_h,v 1.56 1999/10/01 06:33:18 kenelson Exp $ */

/* menu.h
 *
 * Copyright (C) 1998-1999 The Gtk-- Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gtk--/menushell.h>
#include <gtk--/menuitem.h>
#include <gtk/gtkmenu.h>

#include <gtk--/accelgroup.h>

class Gtk_Menu;
class Gtk_Menu_Class;
template <> struct Gtk_Wrap<GtkMenu> {typedef Gtk_Menu CppType;};

class Gtk_Menu : public Gtk_MenuShell {

public:
  typedef Gtk_Menu          CppObjectType;
  typedef Gtk_Menu_Class    CppClassType;
  typedef GtkMenu           BaseObjectType;
  typedef GtkMenuClass      BaseClassType;

private:
  friend CppClassType;
  static CppClassType menu_class;

  Gtk_Menu(const Gtk_Menu&);
  Gtk_Menu& operator=(const Gtk_Menu&); // not implemented

protected:
  void   initialize_class();
  void*  get_parent_class() { return static_cast<void*>(parent_class_); }

  static void    init_parent_class()
    { Gtk_MenuShell::get_type(); }
  explicit Gtk_Menu(GtkMenu *castitem);

public:
  static GtkType get_type();
  GtkMenu* gtkobj()             { return GTK_MENU(gtkobject); }
  const GtkMenu* gtkobj() const { return GTK_MENU(gtkobject); }
  static bool isA(Gtk_Object *checkcast);

  // Hook for proxies
  static const char* const signal_names[];

  virtual ~Gtk_Menu();

private:

public:

  Gtk_Menu();



  //: append a menu item


  void append(Gtk_MenuItem& child);

  //: insert a menu item in first position


  void prepend(Gtk_MenuItem& child);
  //: insert a menu item at specified position



  void insert(Gtk_MenuItem& child,gint position);

  //: Display the menu on screen
  // When there is a parent menu

  void popup(Gtk_MenuShell& parent_menu_shell,Gtk_MenuItem& parent_menu_item,GtkMenuPositionFunc func,gpointer data,guint button,guint32 activate_time);
  // When there isn't
  void popup                        (GtkMenuPositionFunc func,
				     gpointer data,
				     guint button,
				     guint32 activate_time);
  //: Hides the menu away


  void popdown();

  //- Keep track of the last menu item selected, for the purposes
  //- of the option menu


  Gtk_MenuItem* get_active() const;



  void set_active(gint index);

  //- Position the menu according to it's position function. This wraps
  //- a function called by gtkmenuitem.c when a menu-item changes
  //- its allocation. You most likely don't need to care about it.


  void reposition();

  // The accel group may or may not be there


  void set_accel_group(Gtk_AccelGroup* accel_group=0);


  void set_accel_group(Gtk_AccelGroup& accel_group);


  Gtk_AccelGroup* get_accel_group() const;
#if GTK_VERSION_GT_MICRO(1,2,0)
  Gtk_AccelGroup* get_uline_accel_group     () const;
  Gtk_AccelGroup* ensure_uline_accel_group () const;
#endif



  void set_tearoff_state(bool torn_off);

  //- Sets the window manager title for the window that
  //- appears when a menu is torn off


  void set_title(const gtkmm_string& title);

  void reorder_child(const Gtk_MenuItem &child, gint position);

protected:
  //- Attach the menu to a widget. {\var detacher} is a function which takes
  //- the attached GtkWidget* and GtkMenu*
  //- ({\b NOTE! NOT the Gtk_Widget and Gtk_Menu!})
  //- This is mostly used by other widgets like {\class Gtk_MenuItem} or
  //- {\class Gtk_NoteBook}. You probably don't need to care about it.


  void attach_to_widget(Gtk_Widget& widget,GtkMenuDetachFunc detacher);

public:


  Gtk_Widget* get_attach_widget() const;

  //- Detach the menu from the widget it was attached to
  //- (calls the passed {\var detacher} function)


  void detach();

public:
#ifndef GTKMM_CXX_GAUB
  union
    {
#endif
      CppObjectType *menu_self;
#ifndef GTKMM_CXX_GAUB
    };
#endif

protected:
  // impl functions

};


//+ PROPERTIES(Gtk_Menu)
//. name: parent_menu_item
//. type: Gtk_Widget*
//. get: none
//. set: {popup()}
//. desc:

//. name: accel_group
//. type: GtkAccelGroup*
//. get:
//. set: {set_accel_group()}
//. desc:

//. name: position_func
//. type: GtkMenuPositionFunc
//. get: none
//. set: {popup()}
//. desc: A function taking a GtkMenu* ({\b NOTE! NOT a Gtk_Menu!}),
//. pointers to x and y gint coordinates and a pointer to some user
//. data. The function should set x and y to where the menu will be
//. positioned on the screen

//. name: position_func_data
//. type: gpointer
//. get: none
//. set: {popup()}
//. desc: user data which will be passed to {position_func}

//. name: torn_off
//. type: bool
//. get: none
//. set: {set_tearoff_state()}
//. desc: Whether the menu is torn off (detached) or not.

#endif
