// -*- c++ -*-
//  Generated by gtkmmproc from ./../menushell.gen_h -- DO NOT MODIFY!
#ifndef _GTKMM_MENUSHELL_H
#define _GTKMM_MENUSHELL_H

/* $Id: menushell.gen_h,v 1.52 1999/11/05 18:50:35 kenelson Exp $ */

/* menushell.h
 *
 * Copyright (C) 1998-1999 The Gtk-- Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gdk/gdkkeysyms.h>
#include <gtk/gtkmenushell.h>
#include <gtk/gtkmenuitem.h>
#include <gtk--/container.h>
#include <gtk--/radiomenuitem.h>
#include <gtk--/checkmenuitem.h>
#include <gtk--/menuitem.h>
#include <gtk--/label.h>
class Gtk_MenuShell;
class Gtk_MenuShell_Class;
template <> struct Gtk_Wrap<GtkMenuShell> {typedef Gtk_MenuShell CppType;};

class Gtk_MenuShell;

#ifdef GTKMM_CXX_HAVE_NAMESPACES
namespace Gtk_Menu_Helpers
#else
struct Gtk_Menu_Helpers
#endif
{

/*********************************************************************
***** Menu Properties
*********************************************************************/

  // output class
  class Menu : protected GtkMenuItem
    {
      private:
        Menu& operator=(const Menu&);
        Menu(const Menu&);

      protected:
        Menu(void* do_not_derive_this);

      public:
        GtkMenuItem* gtkobj(void) {return (this);}
        Gtk_Widget *menuitem(void);
    };



  // input class (MenuItem-Factory)
  class Element
    {
      protected:
        Gtk_Widget *child_;

      public:
        Element(Gtk_Widget* child)
            : child_(child)
          {}
        Element(Gtk_Widget& child)
            : child_(&child)
          {}

        inline Gtk_Widget *get_child() const { return child_; }
    };


  class MenuElem : public Element
    {
      public:
        MenuElem(Gtk_MenuItem& child)
            : Element(&child)
          {}
        MenuElem(Gtk_MenuItem* child)
            : Element(child)
          {}

        // create a labeled, non-accelerated menuitem with a callback
        MenuElem(const string &label, Slot0<void> callback = 0,
                 const string &accel_signal = "activate")
            : Element(0)
          {
             // TODO
             // g_return_if_fail(accel_signal is a valid signal for Gtk_MenuItem);

             Gtk_Label    *gtk_label    = manage(new Gtk_Label(label, 0.0, 0.5));
             Gtk_MenuItem *gtk_menuitem = manage(new Gtk_MenuItem());
             gtk_menuitem->add(*gtk_label);
             child_ = gtk_menuitem;

             if (callback)
               {
                 if(accel_signal == "activate")
                   gtk_menuitem->activate.connect(callback);
                 else
                   g_warning("Gtk_Menu_Helpers::MenuElem: Connecting to signal \"%s\" "
                             "not yet implemented\n", accel_signal.c_str());
               }
             gtk_menuitem->show_all();
          }

        // create a labeled, accelerated menuitem with a callback
        MenuElem(const string &label, Gtk_AccelGroup *accgrp,
                 Slot0<void> callback = 0,
                 GdkModifierType accel_mods = GDK_CONTROL_MASK,
                 const string &accel_signal = "activate")
            : Element(0)
          {
             // TODO
             // g_return_if_fail(accel_signal is a valid signal for Gtk_MenuItem);

             Gtk_Label    *gtk_label    = manage(new Gtk_Label(label, 0.0, 0.5));
             Gtk_MenuItem *gtk_menuitem = manage(new Gtk_MenuItem());
             gtk_menuitem->add(*gtk_label);
             child_ = gtk_menuitem;

             guint key = gtk_label->parse_uline(label);
             if(key != GDK_VoidSymbol)
             {
               if(accgrp)
                 gtk_menuitem->add_accelerator(accel_signal, *accgrp, key,
                          accel_mods, GtkAccelFlags(GTK_ACCEL_VISIBLE | GTK_ACCEL_SIGNAL_VISIBLE));
               else
                 g_warning("Gtk_Menu_Helpers::MenuElem: You defined an accelarator key "
                           "but did not provide a Gtk_AccelGroup*");
             }

             if (callback)
             {
               if(accel_signal == "activate")
                 gtk_menuitem->activate.connect(callback);
               else
                 g_warning("Gtk_Menu_Helpers::MenuElem: Connecting to signal \"%s\" "
                           "not yet implemented\n", accel_signal.c_str());
             }
             gtk_menuitem->show_all();
          }


        // some convenience functions from Gtk_MenuItem
        void set_submenu(const Gtk_Menu &submenu)
          { get_child()->set_submenu(submenu); }

        void remove_submenu(void)
          { get_child()->remove_submenu(); }

        void right_justify(void)
          { get_child()->right_justify(); }

        void set_placement(GtkSubmenuPlacement placement)
          { get_child()->set_placement(placement); }


        inline Gtk_MenuItem *get_child(void) const
          { return static_cast<Gtk_MenuItem*>(child_); }
    };

  class SeparatorElem : public Element
    {
      public:
        SeparatorElem(void)
            : Element(0)
          {
             Gtk_MenuItem *gtk_menuitem = manage(new Gtk_MenuItem());
             child_ = gtk_menuitem;
             gtk_menuitem->show();
          }

        inline Gtk_MenuItem *get_child(void) const
          { return static_cast<Gtk_MenuItem*>(child_); }
    };

  class CheckMenuElem : public MenuElem
    {
      public:
        CheckMenuElem(Gtk_CheckMenuItem& child)
            : MenuElem(&child)
          {}
        CheckMenuElem(Gtk_CheckMenuItem* child)
            : MenuElem(child)
          {}

        // create a labeled, non-accelerated menuitem with a callback
        CheckMenuElem(const string &label, Slot0<void> callback = 0,
                 const string &accel_signal = "toggled")
            : MenuElem(0)
          {
             // TODO
             // g_return_if_fail(accel_signal is a valid signal for Gtk_CheckMenuItem);

             Gtk_Label         *gtk_label    = manage(new Gtk_Label(label, 0.0, 0.5));
             Gtk_CheckMenuItem *gtk_menuitem = manage(new Gtk_CheckMenuItem());
             gtk_menuitem->add(*gtk_label);
             child_ = gtk_menuitem;

             if (callback)
               {
                 if(accel_signal == "toggled")
                   gtk_menuitem->toggled.connect(callback);
                 else
                   g_warning("Gtk_Menu_Helpers::CheckMenuElem: Connecting to signal \"%s\" "
                             "not yet implemented\n", accel_signal.c_str());
               }
             gtk_menuitem->show_all();
          }


        // create a labeled, accelerated checkmenuitem with a callback
        CheckMenuElem(const string &label, Gtk_AccelGroup *accgrp,
                      Slot0<void> callback = 0,
                      const string &accel_signal = "toggled",
                      GdkModifierType accel_mods = GDK_CONTROL_MASK)
            : MenuElem(0)
          {
             Gtk_Label         *gtk_label    = manage(new Gtk_Label(label, 0.0, 0.5));
             Gtk_CheckMenuItem *gtk_menuitem = manage(new Gtk_CheckMenuItem());
             gtk_menuitem->add(*gtk_label);
             child_ = gtk_menuitem;

             guint key = gtk_label->parse_uline(label);
             if(key != GDK_VoidSymbol)
             {
               if(accgrp)
                 gtk_menuitem->add_accelerator(accel_signal, *accgrp, key,
                          accel_mods, GtkAccelFlags(GTK_ACCEL_VISIBLE | GTK_ACCEL_SIGNAL_VISIBLE));
               else
                 g_warning("Gtk_Menu_Helpers::CheckMenuElem: You defined an accelarator key "
                           "but did not provide a Gtk_AccelGroup*");
             }

             if (callback)
             {
               if(accel_signal == "toggled")
                 gtk_menuitem->toggled.connect(callback);
               else
                 g_warning("Gtk_Menu_Helpers::CheckMenuElem: Connecting to signal \"%s\" "
                           "not yet implemented\n", accel_signal.c_str());
             }
             gtk_menuitem->show_all();
          }


        // some convenience functions from Gtk_CheckMenuItem
        void set_active(bool state)
          { get_child()->set_active(state); }

        void set_show_toggle(bool always)
          { get_child()->set_show_toggle(always); }


        inline Gtk_CheckMenuItem *get_child(void) const
          { return static_cast<Gtk_CheckMenuItem*>(child_); }
    };


  class RadioMenuElem : public CheckMenuElem
    {
      public:
        RadioMenuElem(Gtk_RadioMenuItem& child)
            : CheckMenuElem(&child)
          {}
        RadioMenuElem(Gtk_RadioMenuItem* child)
            : CheckMenuElem(child)
          {}

        // create a labeled, non-accelerated menuitem with a callback
        RadioMenuElem(GSList *group, const string &label, Slot0<void> callback = 0,
                      const string &accel_signal = "toggled")
            : CheckMenuElem(0)
          {
             // TODO
             // g_return_if_fail(accel_signal is a valid signal for Gtk_RadioMenuItem);

             Gtk_Label         *gtk_label    = manage(new Gtk_Label(label, 0.0, 0.5));
             Gtk_RadioMenuItem *gtk_menuitem = manage(new Gtk_RadioMenuItem(group));
             gtk_menuitem->add(*gtk_label);

             child_ = gtk_menuitem;

             if (callback)
               {
                 if(accel_signal == "toggled")
                   gtk_menuitem->toggled.connect(callback);
                 else
                   g_warning("Gtk_Menu_Helpers::RadioMenuElem: Connecting to signal \"%s\" "
                             "not yet implemented\n", accel_signal.c_str());
               }
             gtk_menuitem->show_all();
          }


        // create a labeled, accelerated checkmenuitem with a callback
        RadioMenuElem(GSList *group, const string &label, Gtk_AccelGroup *accgrp,
                      Slot0<void> callback = 0,
                      const string &accel_signal = "toggled",
                      GdkModifierType accel_mods = GDK_CONTROL_MASK)
            : CheckMenuElem(0)
          {
             Gtk_Label         *gtk_label    = manage(new Gtk_Label(label, 0.0, 0.5));
             Gtk_RadioMenuItem *gtk_menuitem = manage(new Gtk_RadioMenuItem(group));
             gtk_menuitem->add(*gtk_label);
             child_ = gtk_menuitem;

             guint key = gtk_label->parse_uline(label);
             if(key != GDK_VoidSymbol)
             {
               if(accgrp)
                 gtk_menuitem->add_accelerator(accel_signal, *accgrp, key,
                          accel_mods, GtkAccelFlags(GTK_ACCEL_VISIBLE | GTK_ACCEL_SIGNAL_VISIBLE));
               else
                 g_warning("Gtk_Menu_Helpers::RadioMenuElem: You defined an accelarator key "
                           "but did not provide a Gtk_AccelGroup*");
             }

             if (callback)
             {
               if(accel_signal == "toggled")
                 gtk_menuitem->toggled.connect(callback);
               else
                 g_warning("Gtk_Menu_Helpers::RadioMenuElem: Connecting to signal \"%s\" "
                           "not yet implemented\n", accel_signal.c_str());
             }
             gtk_menuitem->show_all();
          }

        // some convenience functions from Gtk_RadioMenuItem
        GSList *group(void)
          { return get_child()->group(); }

        void set_group(GSList *group)
          { get_child()->set_group(group); }


        inline Gtk_RadioMenuItem *get_child(void) const
          { return static_cast<Gtk_RadioMenuItem*>(child_); }
    };


    // XXX we have Gtk_TearOffMenuItem missing

/*********************************************************************
***** List properties
*********************************************************************/

  class MenuList
    {
      public:
        typedef Menu*                       value_type;
        typedef value_type &                       reference;
        typedef const value_type &                 const_reference;

        typedef G_List_Iterator<value_type>        iterator;
        typedef G_List_ConstIterator<iterator>     const_iterator;
        typedef G_List_ReverseIterator<iterator>   reverse_iterator;
        typedef G_List_ConstIterator<reverse_iterator>   const_reverse_iterator;

        typedef size_t                             difference_type;
        typedef size_t                             size_type;

      private:
        friend Gtk_MenuShell;
        Gtk_MenuShell *parent_;
        explicit MenuList(Gtk_MenuShell* parent): parent_(parent) {}

        GList*& glist() const;      // front of list

        iterator begin_() const;
        iterator end_() const;

      public:
        ~MenuList() {}

        inline iterator begin()
          {return begin_();}
        inline iterator end()
          {return end_();}

        inline const_iterator begin() const
          { return const_iterator(begin_()); }
        inline const_iterator end() const
          { return const_iterator(end_()); }

        inline reverse_iterator rbegin()
          { return reverse_iterator(end_()); }
        inline reverse_iterator rend()
          { return reverse_iterator(begin_()); }

        inline const_reverse_iterator rbegin() const
          { return const_reverse_iterator(reverse_iterator(end_())); }
        inline const_reverse_iterator rend() const
          { return const_reverse_iterator(reverse_iterator(begin_())); }

        size_type size(void) const;
        inline size_type max_size(void) { return size_type(-1); }
        inline bool empty(void) { return glist() == 0; }

        iterator insert(iterator position, const Element& e);
        template <class InputIterator>
        inline void insert(iterator position, InputIterator first, InputIterator last)
          { for (;first!=last;++first) position=insert(position,*first); }

        inline void push_front(const Element& e) { insert(begin(), e); }
        inline void push_back(const Element& e)  { insert(end(), e); }
        inline void pop_front()                  { erase(begin()); }
        inline void pop_back()                   { erase(--end()); }

        //reference front()                 { return *begin(); }
        //const_reference front() const     { return *begin(); }
        //reference back()                  { return *(--end()); }
        //const_reference back() const      { return *(--end()); }

        void clear();

        iterator erase(iterator);
        void erase(iterator start, iterator stop);
        void remove(const_reference);

        void remove(Gtk_Widget& w);

     };

};

class Gtk_MenuShell : public Gtk_Container
{

public:
  typedef Gtk_MenuShell          CppObjectType;
  typedef Gtk_MenuShell_Class    CppClassType;
  typedef GtkMenuShell           BaseObjectType;
  typedef GtkMenuShellClass      BaseClassType;

private:
  friend CppClassType;
  static CppClassType menu_shell_class;

  Gtk_MenuShell(const Gtk_MenuShell&);
  Gtk_MenuShell& operator=(const Gtk_MenuShell&); // not implemented

protected:
  void   initialize_class();
  void*  get_parent_class() { return static_cast<void*>(parent_class_); }

  static void    init_parent_class()
    { Gtk_Container::get_type(); }
  explicit Gtk_MenuShell(GtkMenuShell *castitem);

public:
  static GtkType get_type();
  GtkMenuShell* gtkobj()             { return GTK_MENU_SHELL(gtkobject); }
  const GtkMenuShell* gtkobj() const { return GTK_MENU_SHELL(gtkobject); }
  static bool isA(Gtk_Object *checkcast);

  // Hook for proxies
  static const char* const signal_names[];

  virtual ~Gtk_MenuShell();

private:

public:

  typedef Gtk_Menu_Helpers::MenuList MenuList;





  void append(Gtk_MenuShell& p0);


  void prepend(Gtk_MenuShell& p0);


  void insert(Gtk_MenuShell& p0,gint position);

  MenuList& items() {return items_;}
  const MenuList& items() const {return items_;}

protected:

  Gtk_MenuShell(void);

protected:

  MenuList items_;

public:
#ifndef GTKMM_CXX_GAUB
  union
    {
#endif
      CppObjectType *menu_shell_self;
      EmitProxySignal0<void,CppObjectType,BaseObjectType,0,&gtk_menu_shell_deactivate> deactivate;
      ProxySignal0<void,CppObjectType,BaseObjectType,1> selection_done;
      ProxySignal1<void,GtkMenuDirectionType,CppObjectType,BaseObjectType,2> move_current;
      ProxySignal1<void,gboolean,CppObjectType,BaseObjectType,3> activate_current;
      ProxySignal0<void,CppObjectType,BaseObjectType,4> cancel;
#ifndef GTKMM_CXX_GAUB
    };
#endif

protected:
  // impl functions
    virtual void deactivate_impl();
    virtual void selection_done_impl();
    virtual void move_current_impl(GtkMenuDirectionType p0);
    virtual void activate_current_impl(gboolean p0);
    virtual void cancel_impl();

};


//: Internal class, not for direct use.

//+ PROPERTIES(Gtk_MenuShell)
//. name: children
//. type: GList*
//. get:
//. set:
//. desc:

//. name: active_menu_item
//. type: Gtk_Widget*
//. get:
//. set:
//. desc:

//. name: parent_menu_shell
//. type: Gtk_Widget*
//. get:
//. set:
//. desc:

//. name: active
//. type: guint:1
//. get:
//. set:
//. desc:

//. name: have_grab
//. type: guint:1
//. get:
//. set:
//. desc:

//. name: have_xgrab
//. type: guint:1
//. get:
//. set:
//. desc:

//. name: button
//. type: guint:2
//. get:
//. set:
//. desc:

//. name: ignore_leave
//. type: guint:1
//. get:
//. set:
//. desc:

//. name: menu_flag
//. type: guint:1
//. get:
//. set:
//. desc:

//. name: ignore_enter
//. type: guint:1
//. get:
//. set:
//. desc:

//. name: activate_time
//. type: guint32
//. get:
//. set:
//. desc:

#endif
