// -*- c++ -*-
//  Generated by gtkmmproc from ./../object.gen_h -- DO NOT MODIFY!
#ifndef _GTKMM_OBJECT_H
#define _GTKMM_OBJECT_H

/* $Id: object.gen_h,v 1.64 1999/10/18 03:17:52 kenelson Exp $ */


/* object.h
 *
 * Copyright (C) 1998-1999 The Gtk-- Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/* this file is critical for our compile times, no #includes to this
   header, please */
#include <gtk--/base.h>
#include <gtk/gtkobject.h>

class Gtk_Object;
class Gtk_Object_Class;
template <> struct Gtk_Wrap<GtkObject> {typedef Gtk_Object CppType;};

class Gtk_ArgBase;


//: The base class of the whole hierarchy
class Gtk_Object : public Gtk_Base
  {

public:
  typedef Gtk_Object          CppObjectType;
  typedef Gtk_Object_Class    CppClassType;
  typedef GtkObject           BaseObjectType;
  typedef GtkObjectClass      BaseClassType;

private:
  friend CppClassType;
  static CppClassType object_class;

  Gtk_Object(const Gtk_Object&);
  Gtk_Object& operator=(const Gtk_Object&); // not implemented

protected:
  void   initialize_class();
  void*  get_parent_class() { return static_cast<void*>(parent_class_); }

  static void    init_parent_class()
    { Gtk_Base::get_type(); }
  explicit Gtk_Object(GtkObject *castitem);

public:
  static GtkType get_type();
  GtkObject* gtkobj()             { return GTK_OBJECT(gtkobject); }
  const GtkObject* gtkobj() const { return GTK_OBJECT(gtkobject); }
  static bool isA(Gtk_Object *checkcast);

  // Hook for proxies
  static const char* const signal_names[];

  virtual ~Gtk_Object();

private:

    public:

      guint* signals() { return GTK_OBJECT_SIGNALS (gtkobj()); }
      gint nsignals() { return GTK_OBJECT_NSIGNALS (gtkobj()); }

      guint type() { return GTK_OBJECT_TYPE (gtkobj()); }



#if 0
      // Perhaps tagging that object is bound to C is better than this?

      //: Chunks the Gtk_Object in the Global_Object_Trashcan,
      //:  which is safe to do from inside a callback
      //:  (in effect, 'delete this')
      virtual void delete_self();
#endif


  void set_user_data(gpointer data);

  gpointer get_user_data() const;



  void set_data(const string& key,gpointer data);

  gpointer get_data(const string& key) const;

  gpointer get_data_by_id(GQuark data_id) const;

      // These are really dangerous.  Do we really need them?
//      vector<Gtk_ArgBase*>* getv(guint n_args);
//      void setv                 (const vector<Gtk_ArgBase*> &args);

//      static void add_arg_type  (const string &arg_name,
//    			     GtkType	 arg_type,
//    			     guint		 arg_flags,
//    			     guint		 arg_id);

  void set_data_full(const string& key,gpointer data,GtkDestroyNotify destroy);




  void set_data_by_id(GQuark data_id,gpointer data);

  void set_data_by_id_full(GQuark data_id,gpointer data,GtkDestroyNotify destroy);


  void remove_data(const string& key);

  void remove_no_notify(const string& key);

  void remove_data_by_id(GQuark data_id);

  void remove_no_notify_by_id(GQuark data_id);

#ifdef SIGC_CXX_FRIEND_TEMPLATES
//    protected:
#endif
      // This binds the C++ object to C  (internal function!)
      virtual void set_dynamic();

    protected:

      //: This gives full access to gtk.
      GtkObject *gtkobject;

      void      *parent_class_;

      // flag to indicate we have a reference.
      bool referenced_;

      static void destroy_notify_(gpointer s);

  void ref();

  void unref();
      // hooks for libsigc++
      virtual void reference();
      virtual void unreference();




  void weakref(GtkDestroyNotify notify,gpointer data);




  void weakunref(GtkDestroyNotify notify,gpointer data);

      static void gtkmm_sigsegv(const char *name);

      friend class Gtk_MenuPath;

public:
#ifndef GTKMM_CXX_GAUB
  union
    {
#endif
      CppObjectType *object_self;
      EmitProxySignal0<void,CppObjectType,BaseObjectType,0,&gtk_object_destroy> destroy;
#ifndef GTKMM_CXX_GAUB
    };
#endif

protected:
  // impl functions
    virtual void destroy_impl();

};

#if 0
extern Gtk_Trashcan<Gtk_Object> Global_Object_Trashcan;
#endif


//+ PROPERTIES(gtkobject)
//. name: flags
//. type: guint32
//. get:
//. set:
//. desc: 32 bits of flags. GtkObject only uses 4 of these bits and
//. GtkWidget uses the rest. This is done because structs are
//. aligned on 4 or 8 byte boundaries. If a new bitfield were
//. used in GtkWidget much space would be wasted.
//.

//. name: ref_count
//. type: guint
//. get:
//. set:
//. desc: reference count.
//. refer to the file docs/refcounting.txt on this issue.
//.

//. name: object_data
//. type: GData*
//. get:
//. set:
//. desc: A list of keyed data pointers, used for e.g. the list of signal
//. handlers or an object's user_data.
//.

#endif
