// -*- c++ -*-
//  Generated by gtkmmproc from ./../statusbar.gen_h -- DO NOT MODIFY!
#ifndef _GTKMM_STATUSBAR_H
#define _GTKMM_STATUSBAR_H

/* $Id: statusbar.gen_h,v 1.39 1999/10/19 08:50:53 kenelson Exp $ */

/* statusbar.h
 *
 * Copyright (C) 1998-1999 The Gtk-- Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gtk--/box.h>
#include <gtk/gtkstatusbar.h>

class Gtk_Statusbar;
class Gtk_Statusbar_Class;
template <> struct Gtk_Wrap<GtkStatusbar> {typedef Gtk_Statusbar CppType;};

#ifdef GTKMM_CXX_HAVE_NAMESPACES
namespace Gtk_Statusbar_Helpers
#else
struct Gtk_Statusbar_Helpers
#endif
{
  class Message: protected GtkStatusbarMsg
    {
      private:
        Message& operator=(const Message&);
        Message(const Message&);
      protected:
        Message(void* do_not_derive_this);
      public:
        inline string get_text() {return text;}
        inline guint get_context_id() {return context_id;}
        inline guint get_message_id() {return message_id;}
    };

  struct Element
    {
     guint context_id;
     string message;
     Element(const char* str) : context_id(1), message(str) {}
     Element(const string& str) : context_id(1), message(str) {}
     Element(guint cid,const string& str) : context_id(cid), message(str) {}
    };

  class MsgList
    {
      public:
        typedef Message*                           value_type;
        typedef value_type &                       reference;
        typedef const value_type &                 const_reference;

        typedef G_SList_Iterator<value_type>       iterator;
        typedef G_List_ConstIterator<iterator>     const_iterator;

        typedef size_t                             difference_type;
        typedef size_t                             size_type;

      private:
        friend Gtk_Statusbar;
        Gtk_Statusbar *parent_;
        explicit MsgList(Gtk_Statusbar* parent): parent_(parent) {}

        GSList*& glist() const;

      public:
        ~MsgList() {}

        iterator begin();
        iterator end();

        inline const_iterator begin() const
          { return const_iterator(begin()); }
        inline const_iterator end() const
          { return const_iterator(end()); }

        void push_front(const Element& e);
        inline void pop_front() { erase(begin()); }

        inline void clear() { erase(begin(),end()); }
        size_type size(void) const;
        inline size_type max_size(void) { return size_type(-1); }
        inline bool empty(void) { return glist() == 0; }

        iterator erase(iterator);
        void erase(iterator start, iterator stop);
        void remove(const_reference);
    };

};

//: Text status indicator
//- This widget is used to display status information.
//- Messages are pushed and poped onto a message stack.
//- When text is pushed it replaces the old contents.
//- The old text is restored when popped.
//-
//- It derives from Gtk_HBox so that additional information can be added
//- easily.
//-
//- The message list can be accessed through the messages() list.
class Gtk_Statusbar : public Gtk_HBox
{

public:
  typedef Gtk_Statusbar          CppObjectType;
  typedef Gtk_Statusbar_Class    CppClassType;
  typedef GtkStatusbar           BaseObjectType;
  typedef GtkStatusbarClass      BaseClassType;

private:
  friend CppClassType;
  static CppClassType statusbar_class;

  Gtk_Statusbar(const Gtk_Statusbar&);
  Gtk_Statusbar& operator=(const Gtk_Statusbar&); // not implemented

protected:
  void   initialize_class();
  void*  get_parent_class() { return static_cast<void*>(parent_class_); }

  static void    init_parent_class()
    { Gtk_HBox::get_type(); }
  explicit Gtk_Statusbar(GtkStatusbar *castitem);

public:
  static GtkType get_type();
  GtkStatusbar* gtkobj()             { return GTK_STATUSBAR(gtkobject); }
  const GtkStatusbar* gtkobj() const { return GTK_STATUSBAR(gtkobject); }
  static bool isA(Gtk_Object *checkcast);

  // Hook for proxies
  static const char* const signal_names[];

  virtual ~Gtk_Statusbar();

private:

public:
  typedef Gtk_Statusbar_Helpers::MsgList MsgList;

  Gtk_Statusbar();

  guint get_context_id(const gtkmm_string& context_description) const;




  guint push(guint context_id,const gtkmm_string& text);



  void pop(guint context_id);

  typedef G_SList_Iterator < GtkStatusbarMsg * > iterator;
  iterator messages_begin() { return iterator(gtkobj()->messages);}
  iterator messages_end() { return iterator(static_cast<GSList*>(0));}


  void remove_message(guint context_id,guint message_id);


  inline MsgList& messages()             { return msglist_; }
  inline const MsgList& messages() const { return msglist_; }

private:
  MsgList msglist_;

public:
#ifndef GTKMM_CXX_GAUB
  union
    {
#endif
      CppObjectType *statusbar_self;
      ProxySignal2<void,guint,const gchar*,CppObjectType,BaseObjectType,0> text_pushed;
      ProxySignal2<void,guint,const gchar*,CppObjectType,BaseObjectType,1> text_popped;
#ifndef GTKMM_CXX_GAUB
    };
#endif

protected:
  // impl functions
    virtual void text_pushed_impl(guint p0,const gchar* p1);
    virtual void text_popped_impl(guint p0,const gchar* p1);

};


//+ PROPERTIES(Gtk_StatusBar)
//. name: frame
//. type: Gtk_Widget*
//. get:
//. set:
//. desc:

//. name: label
//. type: Gtk_Widget*
//. get:
//. set:
//. desc:

//. name: messages
//. type: GSList*
//. get:
//. set:
//. desc:

//. name: keys
//. type: GSList*
//. get:
//. set:
//. desc:

//. name: seq_context_id
//. type: guint
//. get:
//. set:
//. desc:

//. name: seq_message_id
//. type: guint
//. get:
//. set:
//. desc:

#endif
