// -*- c++ -*-
//  Generated by gtkmmproc from ./../toolbar.gen_h -- DO NOT MODIFY!
#ifndef _GTKMM_TOOLBAR_H
#define _GTKMM_TOOLBAR_H

/* $Id: toolbar.gen_h,v 1.75 1999/11/05 18:50:35 kenelson Exp $ */


/* toolbar.h
 *
 * Copyright (C) 1998-1999 The Gtk-- Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gtk--/container.h>
#include <gtk/gtktoolbar.h>

class Gtk_Toolbar;
class Gtk_Toolbar_Class;
template <> struct Gtk_Wrap<GtkToolbar> {typedef Gtk_Toolbar CppType;};

/* toolbar is a bit of a factory.  We will
represent this by making a virtual list called
tools.  Tools iterates through the children
of list.  It looks like list<Gtk_Toolbar_Helpers::Tool*>
but inserts Gtk_Toolbar::Element.  Elements
are a factory for spaces, widget, buttons, toggle
buttons and radio buttons.

The name "icon" in the gtk+ interface is very
misleading, it is really a button content
not a pixmap.  We will rename it to "content".

Confused?  Okay go read the interface.
*/
class Gtk_Toolbar;

#ifdef GTKMM_CXX_HAVE_NAMESPACES
namespace Gtk_Toolbar_Helpers
#else
struct Gtk_Toolbar_Helpers
#endif
{
/*********************************************************************
***** Elem classes (This should be an easy and cool interface)
*********************************************************************/

  // Tool is the output class (very thin wrapper)
  class Tool: protected GtkToolbarChild
    {
      private:
        Tool& operator=(const Tool&);
        Tool(const Tool&);
      protected:
        Tool(void* do_not_derive_this);
      public:
        GtkToolbarChildType get_type() {return GtkToolbarChild::type;}
        Gtk_Widget* get_widget();
        Gtk_Widget* get_content();
        Gtk_Label*  get_label();
    };

  // Element is the input class
  class ToolList;
  class Element
    {
      friend class ToolList;
      protected:
        GtkToolbarChildType  type_;
        Gtk_Widget*          widget_;
        gtkmm_string          text_;
        gtkmm_string          tooltip_text_;
        gtkmm_string          tooltip_private_text_;
        Gtk_Widget*          content_;  // this does not need to be a pixmap.
        Slot0<void>          callback_;

      private:
        Element& operator=(const Element&);

      protected:
        // some fields are mutually exclusive
        Element(GtkToolbarChildType  type,
                Gtk_Widget          *widget,
                const gtkmm_string   &text,
                const gtkmm_string   &tooltip_text,
                const gtkmm_string   &tooltip_private_text,
                Gtk_Widget          *content,
                Slot0<void>          callback);
      public:
        Element(const Element& p);

        Element(Gtk_Widget& w,
                const gtkmm_string &tooltip_text=0,
                const gtkmm_string &tooltip_private_text=0);
    };

  struct Space: public Element
    {
      Space();
    };

  typedef Element WidgetElem;

  // Order here is different than gtk+, watch yourself
  // Each button set has 3 forms i
  //   with a string and content
  //   with a string
  //   with content (ie Pixmap, images, etc)
  struct ButtonElem: public Element
    {
      ButtonElem(const gtkmm_string &text,
                 Gtk_Widget         &content,
                 Slot0<void>        callback,
                 const gtkmm_string &tooltip_text=0,
                 const gtkmm_string &tooltip_private_text=0);
      ButtonElem(Gtk_Widget         &content,
                 Slot0<void>        callback,
                 const gtkmm_string &tooltip_text=0,
                 const gtkmm_string &tooltip_private_text=0);
      ButtonElem(const gtkmm_string &text,
                 Slot0<void>        callback,
                 const gtkmm_string &tooltip_text=0,
                 const gtkmm_string &tooltip_private_text=0);
    };

  struct ToggleElem: public Element
    {
      ToggleElem(const gtkmm_string &text,
                 Gtk_Widget         &content,
                 Slot0<void>        callback,
                 const gtkmm_string &tooltip_text=0,
                 const gtkmm_string &tooltip_private_text=0);
      ToggleElem(Gtk_Widget         &content,
                 Slot0<void>        callback,
                 const gtkmm_string &tooltip_text=0,
                 const gtkmm_string &tooltip_private_text=0);

      ToggleElem(const gtkmm_string &text,
                 Slot0<void>        callback,
                 const gtkmm_string &tooltip_text=0,
                 const gtkmm_string &tooltip_private_text=0);
    };

  struct RadioElem: public Element
    {
      RadioElem (const gtkmm_string &text,
                 Gtk_Widget         &content,
                 Slot0<void>        callback,
                 const gtkmm_string &tooltip_text=0,
                 const gtkmm_string &tooltip_private_text=0);
      RadioElem (Gtk_Widget         &content,
                 Slot0<void>        callback,
                 const gtkmm_string &tooltip_text=0,
                 const gtkmm_string &tooltip_private_text=0);
      RadioElem (const gtkmm_string &text,
                 Slot0<void>        callback,
                 const gtkmm_string &tooltip_text=0,
                 const gtkmm_string &tooltip_private_text=0);
    };

/*********************************************************************
***** List properties
*********************************************************************/

  class ToolList
    {
      public:
        typedef Tool*                       value_type;
        typedef value_type &                       reference;
        typedef const value_type &                 const_reference;

        typedef G_List_Iterator<value_type>        iterator;
        typedef G_List_ConstIterator<iterator>     const_iterator;
        typedef G_List_ReverseIterator<iterator>   reverse_iterator;
        typedef G_List_ConstIterator<reverse_iterator>   const_reverse_iterator;

        typedef size_t                             difference_type;
        typedef size_t                             size_type;

      private:
        friend Gtk_Toolbar;
        Gtk_Toolbar *parent_;
        explicit ToolList(Gtk_Toolbar* parent): parent_(parent) {}

        GList*& glist() const;      // front of list

        iterator begin_() const;
        iterator end_() const;

      public:
        ~ToolList() {}

        inline iterator begin()
          {return begin_();}
        inline iterator end()
          {return end_();}

        inline const_iterator begin() const
          { return const_iterator(begin_()); }
        inline const_iterator end() const
          { return const_iterator(end_()); }

        inline reverse_iterator rbegin()
          { return reverse_iterator(end_()); }
        inline reverse_iterator rend()
          { return reverse_iterator(begin_()); }

        inline const_reverse_iterator rbegin() const
          { return const_reverse_iterator(reverse_iterator(end_())); }
        inline const_reverse_iterator rend() const
          { return const_reverse_iterator(reverse_iterator(begin_())); }

        size_type size(void) const;
        inline size_type max_size(void) { return size_type(-1); }
        inline bool empty(void) { return glist() == 0; }

        iterator insert(iterator position, const Element& e);
        template <class InputIterator>
        inline void insert(iterator position, InputIterator first, InputIterator last)
          { for (;first!=last;++first) position=insert(position,*first); }

        inline void push_front(const Element& e) { insert(begin(), e); }
        inline void push_back(const Element& e)  { insert(end(), e); }
        inline void pop_front()                  { erase(begin()); }
        inline void pop_back()                   { erase(--end()); }

        //reference front()                 { return *begin(); }
        //const_reference front() const     { return *begin(); }
        //reference back()                  { return *(--end()); }
        //const_reference back() const      { return *(--end()); }

        void clear();

        iterator erase(iterator);
        void erase(iterator start, iterator stop);
        void remove(const_reference);

        iterator find(const_reference c);
        iterator find(Gtk_Widget&);

        // Non-standard
        void remove(Gtk_Widget&);
     };

};
#ifdef GTKMM_CXX_HAVE_NAMESPACES
namespace Gtk_Tools = Gtk_Toolbar_Helpers;
#else
typedef Gtk_Toolbar_Helpers Gtk_Tools;
#endif



class Gtk_Toolbar : public Gtk_Container
{

public:
  typedef Gtk_Toolbar          CppObjectType;
  typedef Gtk_Toolbar_Class    CppClassType;
  typedef GtkToolbar           BaseObjectType;
  typedef GtkToolbarClass      BaseClassType;

private:
  friend CppClassType;
  static CppClassType toolbar_class;

  Gtk_Toolbar(const Gtk_Toolbar&);
  Gtk_Toolbar& operator=(const Gtk_Toolbar&); // not implemented

protected:
  void   initialize_class();
  void*  get_parent_class() { return static_cast<void*>(parent_class_); }

  static void    init_parent_class()
    { Gtk_Container::get_type(); }
  explicit Gtk_Toolbar(GtkToolbar *castitem);

public:
  static GtkType get_type();
  GtkToolbar* gtkobj()             { return GTK_TOOLBAR(gtkobject); }
  const GtkToolbar* gtkobj() const { return GTK_TOOLBAR(gtkobject); }
  static bool isA(Gtk_Object *checkcast);

  // Hook for proxies
  static const char* const signal_names[];

  virtual ~Gtk_Toolbar();

private:

public:
  typedef Gtk_Toolbar_Helpers::ToolList ToolList;

  Gtk_Toolbar(GtkOrientation orientation = GTK_ORIENTATION_HORIZONTAL,
	      GtkToolbarStyle style = GTK_TOOLBAR_BOTH);


// All the gtk+ add methods were horrible interface use tools().

/* Style methods */
  GtkOrientation get_orientation() const;


  void set_orientation(GtkOrientation orientation);


  GtkToolbarStyle get_style() const;
  void set_style(GtkToolbarStyle style);


  gint get_space_size() const;
  void set_space_size(gint space_size);


  GtkToolbarSpaceStyle get_space_style() const;
  void set_space_style(GtkToolbarSpaceStyle space_style);


  void set_tooltips(bool enable);


  GtkReliefStyle get_button_relief() const;
  void set_button_relief(GtkReliefStyle relief);



/* signals (not emitable) */


  ToolList& tools() {return tools_;}
  const ToolList& tools() const {return tools_;}
protected:
  ToolList tools_;

public:
#ifndef GTKMM_CXX_GAUB
  union
    {
#endif
      CppObjectType *toolbar_self;
#ifndef GTKMM_CXX_GAUB
    };
#endif

protected:
  // impl functions
    virtual void orientation_changed_impl(GtkOrientation p0);
    virtual void style_changed_impl(GtkToolbarStyle p0);

};




//+ PROPERTIES(Gtk_ToolBar)
//. name: num_children
//. type: gint
//. get:
//. set:
//. desc:

//. name: children
//. type: GList*
//. get:
//. set:
//. desc:

//. name: orientation
//. type: GtkOrientation
//. get:
//. set:
//. desc:

//. name: style
//. type: GtkToolbarStyle
//. get:
//. set:
//. desc:

//. name: space_size
//. type: gint
//. get:
//. set:
//. desc: big optional space between buttons

//. name: space_style
//. type: GtkToolbarSpaceStyle
//. get:
//. set:
//. desc:

//. name: tooltips
//. type: GtkTooltips*
//. get:
//. set:
//. desc:

//. name: button_maxw
//. type: gint
//. get:
//. set:
//. desc:

//. name: button_maxh
//. type: gint
//. get:
//. set:
//. desc:

//. name: relief
//. type: GtkReliefStyle
//. get:
//. set:
//. desc:

#endif
