// -*- c++ -*-
//  Generated by gtkmmproc from ./../window.gen_h -- DO NOT MODIFY!
#ifndef _GTKMM_WINDOW_H
#define _GTKMM_WINDOW_H

/* $Id: window.gen_h,v 1.62 1999/10/26 16:47:52 kenelson Exp $ */

/* window.h
 *
 * Copyright (C) 1998-1999 The Gtk-- Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gtk--/bin.h>
#include <gtk--/accelgroup.h>
#include <gtk/gtkwindow.h>
class Gtk_Window;
class Gtk_Window_Class;
template <> struct Gtk_Wrap<GtkWindow> {typedef Gtk_Window CppType;};
class Gtk_Window : public Gtk_Bin {

public:
  typedef Gtk_Window          CppObjectType;
  typedef Gtk_Window_Class    CppClassType;
  typedef GtkWindow           BaseObjectType;
  typedef GtkWindowClass      BaseClassType;

private:
  friend CppClassType;
  static CppClassType window_class;

  Gtk_Window(const Gtk_Window&);
  Gtk_Window& operator=(const Gtk_Window&); // not implemented

protected:
  void   initialize_class();
  void*  get_parent_class() { return static_cast<void*>(parent_class_); }

  static void    init_parent_class()
    { Gtk_Bin::get_type(); }
  explicit Gtk_Window(GtkWindow *castitem);

public:
  static GtkType get_type();
  GtkWindow* gtkobj()             { return GTK_WINDOW(gtkobject); }
  const GtkWindow* gtkobj() const { return GTK_WINDOW(gtkobject); }
  static bool isA(Gtk_Object *checkcast);

  // Hook for proxies
  static const char* const signal_names[];

  virtual ~Gtk_Window();

private:

public:

  //: Create a window.
  //- This creates a window with an optional {type}.
  explicit Gtk_Window(GtkWindowType type=GTK_WINDOW_TOPLEVEL);



  //: Set the window {title}.


  void set_title(const gtkmm_string& title);

  //: Set the window manager names.
  //- See {wmclass_name} and {wmclass_class}.



  void set_wmclass(const gtkmm_string& wmclass_name,const gtkmm_string& wmclass_class);

  //: Set the window resizing policy.
  //- See {allow_shrink},{allow_grow}, and {auto_shrink}




  void set_policy(gint allow_shrink,gint allow_grow,gint auto_shrink);



  void add_accel_group(Gtk_AccelGroup& accel_group);



  void remove_accel_group(Gtk_AccelGroup& accel_group);

  //: Set the window position.


  void set_position(GtkWindowPosition position);



  gint activate_focus();



  gint activate_default();



  void set_transient_for(Gtk_Window& parent);





  void set_geometry_hints(Gtk_Widget& geometry_widget,GdkGeometry* geometry,GdkWindowHints geom_mask);




  void set_default_size(gint width,gint height);



  void set_modal(bool modal);

  // set_focus is internal

public:
#ifndef GTKMM_CXX_GAUB
  union
    {
#endif
      CppObjectType *window_self;
#ifndef GTKMM_CXX_GAUB
    };
#endif

protected:
  // impl functions

};


//+ PROPERTIES(Gtk_Window)
//. name: title
//. type: gtkmm_string
//. get:
//. set: {set_title()}
//. desc: Title displayed by window manager for this window.
//.   0 is means this window has no title.
//.
//. Windows with a {type} of {\enum GTK_WINDOW_POPUP} may not display
//. a title even if set.

//. name: wmclass_name
//. type: gtkmm_string
//. get:
//. set: {set_wmclass()}
//. desc: Property used for X window manager.

//. name: wmclass_class
//. type: gtkmm_string
//. get:
//. set: {set_wmclass()}
//. desc: Property used for X window manager.

//. name: type
//. type: GtkWindowType
//. get:
//. set:
//. desc: This flags determine what kind of decorations and behavior this
//. window gets. This information is given to the window manager
//. and it determines how to show the window on the screen.
//. See {\page GtkWindowType}
//.
//. Possible values for GtkWindowType argument are:
//. {\enum GTK_WINDOW_TOPLEVEL}, {\enum GTK_WINDOW_DIALOG},
//. {\enum GTK_WINDOW_POPUP}

//. name: focus_widget
//. type: Gtk_Widget*
//. get:
//. set:
//. desc:

//. name: default_widget
//. type: Gtk_Widget*
//. get:
//. set:
//. desc:

//. name: transient_parent
//. type: Gtk_Window*
//. get:
//. set:
//. desc:

//. name: resize_count
//. type: gushort
//. get:
//. set:
//. desc:

//. name: allow_shrink
//. type: guint:1
//. get:
//. set: {set_policy()}
//. desc: Indicates if shrinking this window is allowed by the user.

//. name: allow_grow
//. type: guint:1
//. get:
//. set: {set_policy()}
//. desc: Indicates if expanding this window is allowed by the user.

//. name: auto_shrink
//. type: guint:1
//. get:
//. set: {set_policy()}
//. desc: Indicates the window shrinks automatically when widgets within it shrink.

//. name: handling_resize
//. type: guint:1
//. get:
//. set:
//. desc:

//. name: position
//. type: guint:2
//. get:
//. set:
//. desc: Determine where the window will be displayed when it is
//. finally drawn to the screen. Currently the following positions and
//. the effect they have on window placement can be specified.
//. See {\page GtkWindowPosition}
//.
//. Possible states are:
//.  {\enum GTK_WIN_POS_NONE},
//.  {\enum GTK_WIN_POS_CENTER},
//.  {\enum GTK_WIN_POS_MOUSE}

//. name: use_uposition
//. type: guint:1
//. get:
//. set:
//. desc: The following flag is initially TRUE when a window is mapped.
//. and will be set to FALSE after it is first positioned.
//. It is also temporarily reset when the window's size changes.
//.
//. When TRUE, we move the window to the position the app set.
//.

//. name: modal
//. type: guint:1
//. get:
//. set:  {set_modal()}
//. desc: A modal window is one that must be responded to before
//.   the user is allowed to return to the application.  Use modal
//.   windows sparingly.


//+ ENUM(GtkWindowPosition)
//. value: GTK_WIN_POS_NONE
//. desc: {\b No position specified.}
//.
//. The window manager is left full freedom to place the window whereever
//. it wants.

//. value: GTK_WIN_POS_CENTER
//. desc: {\b Center window.}
//.
//. This will cause the window to center itself on the the
//. screen. This option setting will take into account the {\b virtual screen}
//.  size
//. when calculating the center. This is not the same as the
//. {\i virtual desktop}
//. setting of many window managers. It will center itself on the current
//. {\i virtual desktop}.

//. value: GTK_WIN_POS_MOUSE
//. desc: {\b User selected position.}
//.
//. This position option will cause the window to center itself under the
//. mouse pointers' current location. Typical uses for this setting is in
//. warning/error/informational dialogs where user interaction is desired.


//+ ENUM(GtkWindowType)
//. value: GTK_WINDOW_TOPLEVEL
//. desc: Used for the main application
//. Window that will remain for the entire application run.

//. value: GTK_WINDOW_DIALOG
//. desc: Used for transient windows with input.
//. These windows will open up, gather some input or provide some
//. application specific updates, then close. The window manager is free not
//. to provide all the 'normal' window functions to this window.

//. value: GTK_WINDOW_POPUP
//. desc: Used for transient windows without input.
//. These
//. windows are typically used for when no user interaction is required, to
//. notify the user of some condition. Other uses for these types of windows
//. are for 'about windows', startup windows and the like.
//.
//. Popup windows often lack decorations and will not be on window lists.
//. They should be able to handle events even though they will {\b not}
//. get kill and close events from the window manager.


#endif
