dnl $Id: convert.m4,v 1.45 1999/11/17 10:56:56 glaurent Exp $ 

#
#  Define a hashing for names
#
define(`__HASH',`__`'translit(`$*',`ABCDEFGHIJKLMNOPQRSTUVWXYZ<>[]&*, ',`abcdefghijklmnopqrstuvwxyzVBNMRSC_')`'')
define(`__HASH2',`__HASH(__EQUIV(`$1'))`'__HASH(__EQUIV(`$2'))')
define(`__EQUIV',`ifdef(EV`'__HASH(`$1'),EV`'__HASH(`$1'),`$1')')

#
#  __FWD_CONVERT(ctype,cpptype,name)
#    Print the conversion from ctype to cpptype
define(`__FWD_CONVERT',`dnl
pushdef(`__H1',`__HASH(`$1')')dnl
pushdef(`__H2',`__HASH(`$2')')dnl
pushdef(`__E1',`ifdef(EV`'__H1,EV`'__H1,__H1)')dnl
pushdef(`__E2',`ifdef(EV`'__H2,EV`'__H2,__H2)')dnl
pushdef(`__COV',`CF`'__E1`'__E2')dnl
ifelse(__E1,__E2,`$3',`dnl
ifdef(__COV,`indir(__COV,`$1',`$2',`$3')',`
errprint(`No forward conversion from $1 to $2 defined ($3) 
')')`'dnl
')`'dnl
popdef(`__COV')dnl
popdef(`__E2')dnl
popdef(`__E1')dnl
popdef(`__H2')dnl
popdef(`__H1')dnl
')


#
#  __REV_CONVERT(ctype,cpptype,name)
#    Print the conversion from cpptype to ctype
define(`__REV_CONVERT',`dnl
pushdef(`__H1',`__HASH(`$1')')dnl
pushdef(`__H2',`__HASH(`$2')')dnl
pushdef(`__E1',`ifdef(EV`'__H1,EV`'__H1,__H1)')dnl
pushdef(`__E2',`ifdef(EV`'__H2,EV`'__H2,__H2)')dnl
pushdef(`__COV',`CR`'__E1`'__E2')dnl
ifelse(__E1,__E2,`$3',`dnl
ifdef(__COV,`indir(__COV,`$1',`$2',`$3')',`
errprint(`No reverse conversion from $1 to $2 defined ($3)
')')`'dnl
')`'dnl
popdef(`__COV')dnl
popdef(`__E2')dnl
popdef(`__E1')dnl
popdef(`__H2')dnl
popdef(`__H1')dnl
')


#
#  Functions for populating the tables.
#
define(`GTKMM_CONVERSION',`
ifelse(`$3',,,`define(CF`'__HASH2(`$1',`$2'),`$3')')
ifelse(`$4',,,`define(CR`'__HASH2(`$1',`$2'),`$4')')
')

define(`GTKMM_EQUAL',`define(EV`'__HASH(`$1'),__HASH(`$2'))')

/*******************************************************/


#
#  __FOREACH(list,function)
#    Preform listed action many times.
#
define(`__LOOP',`ifelse(`$*',,,`indir(`LOOP',$*)`'__LOOP(shift($*))')')
define(`__FOREACH',`dnl
pushdef(`LOOP',`$2')dnl
__LOOP(`$1')dnl
popdef(`LOOP')dnl
')


/*******************************************************************/

#
# Table of widgets
#


GTKMM_EQUAL(gboolean,int)
GTKMM_EQUAL(gint,int)
GTKMM_EQUAL(gint*,int*)
GTKMM_EQUAL(gint&,int&)
GTKMM_EQUAL(guint,unsigned int)
GTKMM_EQUAL(guint*,unsigned int*)
GTKMM_EQUAL(guint&,unsigned int&)
GTKMM_EQUAL(gchar,char)
GTKMM_EQUAL(gchar*,char*)
GTKMM_EQUAL(const gchar*,const char*)
GTKMM_EQUAL(GdkAtom,Gdk_Atom)

#
# Basic Types
GTKMM_CONVERSION(`int',`bool',`($1)$3',`$3')
GTKMM_CONVERSION(`unsigned int',`bool',`($1)$3',`$3')
GTKMM_CONVERSION(`int*',`int&',`&$3',`*$3')
GTKMM_CONVERSION(`const char*',`const string&',`$3.c_str()',`$3')
GTKMM_CONVERSION(`const char*',`const gtkmm_string&',`$3.gc_str()',`$3')
GTKMM_CONVERSION(`const char*',`string',`$3.gc_str()',`$3')

# These are for fixmegtkconst
GTKMM_CONVERSION(`gdouble*',`const gdouble*',`const_cast<gdouble*>($3)',`$3')
GTKMM_CONVERSION(`GtkWidget*',`const Gtk_Widget&',`const_cast<GtkWidget*>($3.gtkobj())',`gtkmm_wrap($3)')
GTKMM_CONVERSION(`GtkObject*',`const Gtk_Object&',`const_cast<GtkObject*>($3.gtkobj())',`gtkmm_wrap($3)')
GTKMM_CONVERSION(`guchar*',`const guchar*',`const_cast<guchar*>($3)',`$3')
GTKMM_CONVERSION(`char*',`const gtkmm_string&',`const_cast<$1>($3.gc_str())')

#
# Some reverse conversions
GTKMM_CONVERSION(`char*',`gtkmm_string',`',`$3')
GTKMM_CONVERSION(`char*',`string',`',`$3')
GTKMM_CONVERSION(`gchar*',`string',`',`$3')
GTKMM_CONVERSION(`const gchar*',`const string',`',`$3')
GTKMM_CONVERSION(`const gchar*',`const gtkmm_string',`',`$3')

#
# ENUMS
GTKMM_CONVERSION(`gint16',`GtkShadowType',,`($2)$3')
GTKMM_CONVERSION(`unsigned int',`GtkPolicyType',,`($2)$3')
GTKMM_CONVERSION(`unsigned int',`GtkPositionType',,`($2)$3')
GTKMM_CONVERSION(`unsigned int',`GtkCornerType',,`($2)$3')
GTKMM_CONVERSION(`GtkAttachOptions',`int',`($1)$3',`$3')

dnl GTKMM_CONVERSION(`char*',`const string&',`const_cast<$1>($3.c_str())')
dnl GTKMM_CONVERSION(`char*',`const gtkmm_string&',`const_cast<$1>($3.gc_str())')


# 
# Odd types 
GTKMM_CONVERSION(`GList*',`const G_List_string&',`$3.glist()')
GTKMM_CONVERSION(`GtkStyle*',`Gtk_Style&',`$3.gtkobj()')
GTKMM_CONVERSION(`gchar**',`const Gtk_SArray&',`const_cast<$1>((const char**)$3)')


#
# Gdk types
#

dnl Gdk_Drag_Context,Gdk_Image,Gdk_Bitmap,Gdk_Color,Gdk_Colormap,Gdk_Pixmap,Gdk_Window,dnl
dnl Gdk_Visual,Gdk_Rectangle

GTKMM_CONVERSION(GdkWindow*,Gdk_Window,`$3.gdkobj()',`$3')
GTKMM_CONVERSION(GdkVisual*,Gdk_Visual,`$3.gdkobj()',`$3')
GTKMM_CONVERSION(GdkColormap*,Gdk_Colormap,`$3.gdkobj()',`$3')
GTKMM_CONVERSION(GdkFont*,Gdk_Font,`$3.gdkobj()',`$3')

GTKMM_CONVERSION(GdkDragContext*,Gdk_Drag_Context&,`$3.gdkobj()',`$3')
GTKMM_CONVERSION(GdkWindow*,Gdk_Window&,`$3.gdkobj()',`$3')
GTKMM_CONVERSION(GdkPixmap*,Gdk_Pixmap&,`$3.gdkobj()',`$3')
GTKMM_CONVERSION(GdkBitmap*,Gdk_Bitmap&,`$3.gdkobj()',`$3')
GTKMM_CONVERSION(GdkColormap*,Gdk_Colormap&,`$3.gdkobj()',`$3')

GTKMM_CONVERSION(GdkWindow*,const Gdk_Window&,`const_cast<$1>($3.gdkobj())')
GTKMM_CONVERSION(GdkColormap*,const Gdk_Colormap&,`const_cast<$1>($3.gdkobj())')
GTKMM_CONVERSION(GdkFont*,const Gdk_Font&,`const_cast<$1>($3.gdkobj())')
GTKMM_CONVERSION(GdkVisual*,const Gdk_Visual&,`const_cast<$1>($3.gdkobj())')
GTKMM_CONVERSION(GdkBitmap*,const Gdk_Bitmap&,`const_cast<$1>($3.gdkobj())')
GTKMM_CONVERSION(GdkRectangle*,const Gdk_Rectangle&,`const_cast<$1>($3.gdkobj())')

GTKMM_CONVERSION(GdkImage*,const Gdk_Image&,`const_cast<$1>($3.gdkobj())')
GTKMM_CONVERSION(GdkPixmap*,const Gdk_Pixmap&,`const_cast<$1>($3.gdkobj())')
GTKMM_CONVERSION(const GdkPixmap*,const Gdk_Pixmap&,`$3.gdkobj()')

GTKMM_CONVERSION(GdkColor*,const Gdk_Color&,`const_cast<$1>($3.gdkobj())')
GTKMM_CONVERSION(GdkImlibImage*,const Gdk_ImLib::Image&,`const_cast<$1>($3.gdkobj())')


#
# Widgets that we use with handles.
GTKMM_CONVERSION(GtkObject*,Gtk_ObjectHandle<Gtk_Object>,`$3.obj()')
GTKMM_CONVERSION(Gtk_Widget*,Gtk_ObjectHandle<Gtk_Widget>,`$3.obj()')

#
# Widgets that need gtkobj

#
# Downcast Ptr <=> Ptr (Gtk+ casts don't handle 0 use normal cast)
#
define(`__FP2PD',`($`'1)($`'3?$`'3->gtkobj():0)')
define(`__RP2PD',`gtkmm_wrap((translit($`'2,`_',`'))($`'3))')
GTKMM_CONVERSION(GtkWidget*,Gtk_Box*,__FP2PD,__RP2PD)
GTKMM_CONVERSION(GtkWidget*,Gtk_VBox*,__FP2PD,__RP2PD)
GTKMM_CONVERSION(GtkWidget*,Gtk_HBox*,__FP2PD,__RP2PD)
GTKMM_CONVERSION(GtkWidget*,Gtk_Button*,__FP2PD,__RP2PD)
GTKMM_CONVERSION(GtkWidget*,Gtk_CheckButton*,__FP2PD,__RP2PD)
GTKMM_CONVERSION(GtkWidget*,Gtk_ToggleButton*,__FP2PD,__RP2PD)
GTKMM_CONVERSION(GtkWidget*,Gtk_RadioButton*,__FP2PD,__RP2PD)
GTKMM_CONVERSION(GtkWidget*,Gtk_Scrollbar*,__FP2PD,__RP2PD)
GTKMM_CONVERSION(GtkWidget*,Gtk_HScrollbar*,__FP2PD,__RP2PD)
GTKMM_CONVERSION(GtkWidget*,Gtk_VScrollbar*,__FP2PD,__RP2PD)
GTKMM_CONVERSION(GtkWidget*,Gtk_OptionMenu*,__FP2PD,__RP2PD)
GTKMM_CONVERSION(GtkWidget*,Gtk_List*,__FP2PD,__RP2PD)
GTKMM_CONVERSION(GtkWidget*,Gtk_CList*,__FP2PD,__RP2PD)
GTKMM_CONVERSION(GtkWidget*,Gtk_ColumnList*,__FP2PD,__RP2PD)
GTKMM_CONVERSION(GtkWidget*,Gtk_FontSelection*,__FP2PD,__RP2PD)
GTKMM_CONVERSION(GtkWidget*,Gtk_Window*,__FP2PD,__RP2PD)
GTKMM_CONVERSION(GtkWidget*,Gtk_Entry*,__FP2PD,__RP2PD)
GTKMM_CONVERSION(GtkWidget*,Gtk_Menu*,__FP2PD,__RP2PD)
GTKMM_CONVERSION(GtkWidget*,Gtk_ColorSelection*,__FP2PD,__RP2PD)
GTKMM_CONVERSION(GtkWidget*,Gtk_ScrolledWindow*,__FP2PD,__RP2PD)
GTKMM_CONVERSION(GtkWidget*,Gtk_Label*,__FP2PD,__RP2PD)
GTKMM_CONVERSION(GtkWidget*,Gtk_MenuItem*,__FP2PD,__RP2PD)
GTKMM_CONVERSION(GtkWidget*,Gnome_Dock*,__FP2PD,__RP2PD)
GTKMM_CONVERSION(GtkWidget*,Gnome_Dialog*,__FP2PD,__RP2PD)

GTKMM_CONVERSION(GnomeCanvasItem*,Gnome_CanvasGroup*,,`gtkmm_wrap(GNOME_CANVAS_GROUP($3))')


#
# Ptr => Ptr
#
define(`__FP2P',`($`'3?$`'3->gtkobj():0)')
define(`__RP2P',`gtkmm_wrap($`'3)')
GTKMM_CONVERSION(GtkWidget*,Gtk_Widget*,__FP2P,__RP2P)
GTKMM_CONVERSION(GtkLabel*,Gtk_Label*,__FP2P,__RP2P)
GTKMM_CONVERSION(GtkAdjustment*,Gtk_Adjustment*,__FP2P,__RP2P)
GTKMM_CONVERSION(GtkMenu*,Gtk_Menu*,__FP2P,__RP2P)
GTKMM_CONVERSION(GtkMenuItem*,Gtk_MenuItem*,__FP2P,__RP2P)
GTKMM_CONVERSION(GtkAccelGroup*,Gtk_AccelGroup*,__FP2P,__RP2P)

GTKMM_CONVERSION(GnomeCanvas*,Gnome_Canvas*,,`gtkmm_wrap($3)')

#
# Pointer => Ref
#
GTKMM_CONVERSION(GtkToolbar*,Gtk_Toolbar&,`$3.gtkobj()')
GTKMM_CONVERSION(GtkItem*,Gtk_Item&,`$3.gtkobj()')
GTKMM_CONVERSION(GtkAdjustment*,Gtk_Adjustment&,`$3.gtkobj()')
GTKMM_CONVERSION(GtkAccelGroup*,Gtk_AccelGroup&,`$3.gtkobj()')
GTKMM_CONVERSION(GtkObject*,Gtk_Object&,`$3.gtkobj()')
GTKMM_CONVERSION(GtkWidget*,Gtk_Widget&,`$3.gtkobj()')
GTKMM_CONVERSION(GtkWindow*,Gtk_Window&,`$3.gtkobj()')
GTKMM_CONVERSION(GtkMenuItem*,Gtk_MenuItem&,`$3.gtkobj()')
GTKMM_CONVERSION(GtkMenuShell*,Gtk_MenuShell&,`$3.gtkobj()')
GTKMM_CONVERSION(GtkWindow*,const Gtk_Window&,`const_cast<$1>($3.gtkobj())')

GTKMM_CONVERSION(const GtkWidget*,`const Gtk_Widget&',`$3.gtkobj()')

dnl You must place a GTKMM_CHECK to use this! (see list.gen_h)
GTKMM_CONVERSION(GtkWidget*,Gtk_Widget&,,`*gtkmm_wrap($3)')


#
# Pointer => Ref (Downcast)
#
define(`__FP2RD',`$`'3.$1::gtkobj()')
GTKMM_CONVERSION(GtkWidget*,Gtk_Label&,__FP2RD(Gtk_Widget))
GTKMM_CONVERSION(GtkWidget*,Gtk_Menu&,__FP2RD(Gtk_Widget))
GTKMM_CONVERSION(GtkWidget*,Gtk_MenuShell&,__FP2RD(Gtk_Widget))
GTKMM_CONVERSION(GtkWidget*,Gtk_MenuItem&,__FP2RD(Gtk_Widget))
GTKMM_CONVERSION(GtkWidget*,Gtk_TreeItem&,__FP2RD(Gtk_Widget))


#
# Other Gnome Conversions
#
GTKMM_CONVERSION(GnomeUIInfo*,const Gnome_UIInfo&,`const_cast<Gnome_UIInfo*>(&$3)')
GTKMM_CONVERSION(GnomeUIInfo*,Gnome_UIInfo*,,$3)
GTKMM_CONVERSION(GnomeMDIChild*,`const Gnome_MDIChild&',`const_cast<GnomeMDIChild*>($3.gtkobj())')
GTKMM_CONVERSION(GnomeMDIChild*,`Gnome_MDIChild*',,`gtkmm_wrap($3)')
GTKMM_CONVERSION(GnomeApp*,`Gnome_App*',,`gtkmm_wrap($3)')
GTKMM_CONVERSION(GnomeApp*,`const Gnome_App&',`const_cast<GnomeApp*>($3.gtkobj())')
GTKMM_CONVERSION(GnomeDruidPage*,`const Gnome_DruidPage&',`const_cast<GnomeDruidPage*>($3.gtkobj())')


/*******************************************************************/

# 
# Some test cases
#
A(__FWD_CONVERT(char*,gchar*,foo))
A(__FWD_CONVERT(const gchar*,const string&,foo))
A(__FWD_CONVERT(GdkPixmap*,Gdk_Pixmap&,foo))
A(__FWD_CONVERT(GtkWidget*,Gtk_Widget&,foo))
#A(__FWD_CONVERT(GtkWidget*,`Slot<int,int>',foo))

A(__REV_CONVERT(char*,gchar*,foo))
A(__REV_CONVERT(const gchar*,const string&,foo))
A(__REV_CONVERT(GdkPixmap*,Gdk_Pixmap&,foo))
A(__REV_CONVERT(GtkWidget*,Gtk_Widget*,foo))

A(__REV_CONVERT(GtkWidget*,Gtk_Box*,foo))
A(__FWD_CONVERT(GtkWidget*,Gtk_Box*,foo))

